Globalization and localization in EJ2 JavaScript Pivotview control

Globalization is the combination of Internationalization and localization. You can adapt the component to various languages by parsing and formatting the date or number Internationalization & adding culture specific customization and translation to the text Localization.

Internationalization

Internationalization library provides support for formatting and parsing the number, date, and time by using the official Unicode CLDR JSON data and also provides the loadCldr method to load the culture specific CLDR JSON data.

By default, all the Essential® JS 2 component are specific to English culture (‘en-US’). If you want to go with the different culture other than English, follow the below steps.

  • Install the CLDR-Data package by using the below command (it installs the CLDR JSON data). For more information about CLDR-Data, refer to this link.
npm install cldr-data --save

Once the package installed, you can find the culture specific JSON data under the location /node_modules/cldr-data.

  • Now import the installed CLDR JSON data into the app.ts file. To import JSON data we need to install the JSON plugin loader. Here we have used the SystemJS JSON plugin loader.
npm install systemjs-plugin-json --save-dev
  • Once installed, configure the system.config.js configuration settings as like below to map the
    systemjs-plugin-json loader.
System.config({
    paths: {
        'syncfusion:': './node_modules/@syncfusion/'
    },
    map: {
        app: 'app',

        //Syncfusion packages mapping
        "@syncfusion/ej2-base": "syncfusion:ej2-base/dist/ej2-base.umd.min.js",
        "@syncfusion/ej2-data": "syncfusion:ej2-data/dist/ej2-data.umd.min.js",
        "@syncfusion/ej2-inputs": "syncfusion:ej2-inputs/dist/ej2-inputs.umd.min.js",
        "@syncfusion/ej2-buttons": "syncfusion:ej2-buttons/dist/ej2-buttons.umd.min.js",
        "@syncfusion/ej2-splitbuttons": "syncfusion:ej2-splitbuttons/dist/ej2-splitbuttons.umd.min.js",
        "@syncfusion/ej2-popups": "syncfusion:ej2-popups/dist/ej2-popups.umd.min.js",
        "@syncfusion/ej2-navigations": "syncfusion:ej2-navigations/dist/ej2-navigations.umd.min.js",
        "@syncfusion/ej2-grids": "syncfusion:ej2-grids/dist/ej2-grids.umd.min.js",
        "@syncfusion/ej2-dropdowns": "syncfusion:ej2-dropdowns/dist/ej2-dropdowns.umd.min.js",
        "@syncfusion/ej2-calendars": "syncfusion:ej2-calendars/dist/ej2-calendars.umd.min.js",
        "@syncfusion/ej2-lists": "syncfusion:ej2-lists/dist/ej2-lists.umd.min.js",
        "@syncfusion/ej2-excel-export": "syncfusion:ej2-excel-export/dist/ej2-excel-export.umd.min.js",
        "@syncfusion/ej2-pdf-export": "syncfusion:ej2-pdf-export/dist/ej2-pdf-export.umd.min.js",
        "@syncfusion/ej2-file-utils": "syncfusion:ej2-file-utils/dist/ej2-file-utils.umd.min.js",
        "@syncfusion/ej2-compression": "syncfusion:ej2-compression/dist/ej2-compression.umd.min.js",
        "@syncfusion/ej2-pivotview": "syncfusion:ej2-pivotview/dist/ej2-pivotview.umd.min.js"
    },
    meta: {
        '*.json': { loader: 'plugin-json' }
    },
    packages: {
        'app': { main: 'app', defaultExtension: 'js' },
        'cldr-data': { main: 'index.js', defaultExtension: 'js' }
    }
});

System.import('app');
  • Now import the required culture from the installed location to app.ts file, like the below code snippets.
//import the loadCldr from ej2-base
import { loadCldr} from '@syncfusion/ej2-base';

loadCldr(
    require('cldr-data/supplemental/numberingSystems.json'),
    require('cldr-data/main/fr-CH/ca-gregorian.json'),
    require('cldr-data/main/fr-CH/numbers.json'));
    require('cldr-data/main/fr-CH/timeZoneNames.json'));

The Internationalization library is used to globalize number, date, and time values in pivot table component using the dataSourceSettings.formatSettings option.

  • Set the culture by using the locale property.
ej.base.setCulture('de');
ej.base.setCurrencyCode('EUR');
ej.base.L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer',
        }
    }
});
ej.pivotview.PivotView.Inject(ej.pivotview.FieldList);
var pivotTableObj = new ej.pivotview.PivotView({
    dataSourceSettings: {
        dataSource: pivotData,
        expandAll: false,
        enableSorting: true,
        drilledMembers: [{ name: 'Country', items: ['France'] }],
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        formatSettings: [{ name: 'Amount', format: 'C0', currency: 'EUR' }],
        filters: []
    },
    locale: 'de-DE',
    showFieldList: true,
    height: 350
});
pivotTableObj.appendTo('#PivotTable');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Pivot Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Pivot Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-calendars/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-grids/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-charts/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-pivotview/styles/tailwind3.css" rel="stylesheet">

    <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div>
            <div id="PivotTable"></div>
        </div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

  • In the above sample, Amount field is formatted by NumberFormatOptions. For date formats, the value strings are formatted by DateFormatOptions.
  • By default, locale value is en-US. If you want to change the en-US culture to a different culture, you have to change the locale accordingly.
  • Also, you will find more details about support format string for number formats and data formats here.

Decimal separators

The decimal separators of pivot table values varies based on the culture applied to the component. The culture can be set by calling the method setCulture with appropriate culture string as its parameter.

The following example demonstrates the decimal separators in Deutsch culture.

ej.base.setCulture('de');
loadCultureFiles();
ej.base.setCurrencyCode('EUR');
ej.base.L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer',
        }
    }
});
ej.pivotview.PivotView.Inject(ej.pivotview.FieldList);
var pivotTableObj = new ej.pivotview.PivotView({
    dataSourceSettings: {
        dataSource: pivotData,
        drilledMembers: [{ name: 'Country', items: ['France'] }],
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        formatSettings: [{ name: 'Amount', format: 'C2', currency: 'EUR' }],
        filters: []
    },
    locale: 'de-DE',
    showFieldList: true,
    height: 350
});
function loadCultureFiles() {
        var files = ['ca-gregorian.json', 'numbers.json', 'currencies.json', 'timeZoneNames.json', 'numberingSystems.json'];
        var loader = ej.base.loadCldr;
        var loadCulture = function (prop) {
            var val, ajax;
            ajax = new ej.base.Ajax('./' + files[prop], 'GET', false);
            ajax.onSuccess = function (value) {
                val = value;
            };
            ajax.send();
            loader(JSON.parse(val));
        };
        for (var prop = 0; prop < files.length; prop++) {
            loadCulture(prop);
        }
}
pivotTableObj.appendTo('#PivotTable');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Pivot Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Pivot Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-calendars/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-grids/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-charts/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-pivotview/styles/tailwind3.css" rel="stylesheet">

    <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div>
            <div id="PivotTable"></div>
        </div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Localization

The Localization library allows you to localize default text content of the pivot table. The pivot table component has static text on some features (like drop area text, pivot field list title, etc…) that can be changed to other cultures (Arabic, Deutsch, French, etc.) by defining the
locale value and translation object.

The following list of properties and its values are used in the pivot table.

Locale keywords Text
grandTotal Grand Total
total Total
value Value
noValue No value
row Row
column Column
collapse Collapse
expand Expand
rowAxisPrompt Drop row here
columnAxisPrompt Drop column here
valueAxisPrompt Drop value here
filterAxisPrompt Drop filter here
filter Filter
filtered Filtered
sort Sort
filters Filters
rows Rows
columns Columns
values Values
close Close
cancel Cancel
delete Delete
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
alert Alert
warning Warning
ok OK
search Search
drag Drag
remove Remove
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
addToRow Add to Row
addToColumn Add to Column
addToValue Add to Value
addToFilter Add to Filter
emptyData No records to display
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
all All
multipleItems Multiple items
member Member
label Label
date Date
enterValue Enter value
chooseDate Enter date
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
And and
DistinctCount Distinct Count
Product Product
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
NotEquals Not Equals
AllValues All Values
conditionalFormatting Conditional Formatting
apply APPLY
condition Add Condition
formatLabel Format
valueFieldSettings Value field settings
baseField Base field :
baseItem Base item :
summarizeValuesBy Summarize values by :
sourceName Field name :
sourceCaption Field caption :
example e.g:
editorDataLimitMsg more items. Search to refine further.
details Details
manageRecords Manage Records
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
save Save a report
new Create a new report
load Load
saveAs Save as current report
rename Rename a current report
deleteReport Delete a current report
export Export
subTotals Sub totals
grandTotals Grand totals
reportName Report Name :
pdf PDF
excel Excel
csv CSV
png PNG
jpeg JPEG
svg SVG
mdxQuery MDX Query
showSubTotals Show subtotals
doNotShowSubTotals Do not show subtotals
showSubTotalsRowsOnly Show subtotals rows only
showSubTotalsColumnsOnly Show subtotals columns only
showGrandTotals Show grand totals
doNotShowGrandTotals Do not show grand totals
showGrandTotalsRowsOnly Show grand totals rows only
showGrandTotalsColumnsOnly Show grand totals columns only
fieldList Show fieldlist
grid Show table
toolbarFormatting Conditional formatting
chart Chart
reportMsg Please enter valid report name!!!
reportList Report list
removeConfirm Are you sure want to delete this report?
emptyReport No reports found!!
bar Bar
line Line
area Area
scatter Scatter
polar Polar
of of
emptyFormat No format found!!!
emptyInput Enter a value
newReportConfirm Want to save changes to report?
emptyReportName Enter a report name
qtr Qtr
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
aggregate Aggregate
drillThrough Drill Through
ascending Ascending
descending Descending
number Number
currency Currency
percentage Percentage
formatType Format Type
customText Currency Symbol
symbolPosition Symbol Position
left Left
right Right
grouping Grouping
true True
false False
decimalPlaces Decimal Places
numberFormat Number Formatting
memberType Field Type
formatString Format String
expressionField Expression
customFormat Enter custom format string
selectedHierarchy Parent Hierarchy
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
Percent Percent
Custom Custom
Measure Measure
Dimension Dimension
Standard Standard
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! Then you can achieve it by simply selecting the field under ‘Calculated Members’.
QuarterYear Quarter Year
fieldTitle Field Name
drillError Cannot show the raw items of calculated fields.
caption Field Caption
copy Copy
defaultReport Default report
customFormatString Custom Format
invalidFormat Invalid Format.
group Group
unGroup Ungroup
invalidSelection Cannot group that selection.
groupName Enter the caption to display in header
captionName Enter the caption for group field
selectedItems Selected items
groupFieldCaption Field caption
groupTitle Group name
startAt Starting at
endAt Ending at
groupBy Interval by
selectGroup Select groups
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
stackingcolumn Stacked Column
stackingbar Stacked Bar
stackingarea Stacked Area
stepline Step Line
steparea Step Area
splinearea Spline Area
spline Spline
stackingcolumn100 100% Stacked Column
stackingbar100 100% Stacked Bar
stackingarea100 100% Stacked Area
bubble bubble
pareto Pareto
radar Radar
chartTypeSettings Chart type settings
multipleAxes Multiple Axes
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
ChartType Chart Type
yes Yes
no No
numberFormatMenu Number Formatting…
conditionalFormattingMenu Conditional Formatting…
removeCalculatedField Are you sure you want to delete this calculated field?
replaceConfirmBefore A report named
replaceConfirmAfter already exists. Do you want to replace it?
pie Pie
funnel Funnel
doughnut Doughnut
pyramid Pyramid
showLegend Show Legend
exit Exit
invalidJSON Invalid JSON data
invalidCSV Invalid CSV data
stacked Stacked
single Single
multipleAxisMode Multiple Axis Mode
grandTotalPosition Grand totals position
top Top
bottom Bottom
None None
stackingline Stacked Line
stackingline100 100% Stacked Line
rowPage Row pager
rowPerPage Rows per page
columnPage Column pager
columnPerPage Columns per page
goToFirstPage Go to first page
goToPreviousPage Go to previous page
goToNextPage Go to next page
goToLastPage Go to last page
combined Combined
subTotalPosition Subtotals position
auto Auto

The following list of properties and its values are used in the pivot field list.

Locale keywords Text
staticFieldList Pivot Field List
fieldList Field List
dropFilterPrompt Drop filter here
dropColPrompt Drop column here
dropRowPrompt Drop row here
dropValPrompt Drop value here
addPrompt Add field here
adaptiveFieldHeader Choose field
centerHeader Drag fields between axes below:
add add
drag Drag
filter Filter
filtered Filtered
sort Sort
remove Remove
filters Filters
rows Rows
columns Columns
values Values
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
search Search
close Close
cancel Cancel
delete Delete
alert Alert
warning Warning
ok OK
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
enterValue Enter value
chooseDate Enter date
all All
multipleItems Multiple items
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
member Member
label Label
date Date
value Value
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
And and
DistinctCount Distinct Count
Product Product
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
apply APPLY
valueFieldSettings Value field settings
sourceName Field name :
sourceCaption Field caption :
summarizeValuesBy Summarize values by :
baseField Base field :
baseItem Base item :
example e.g:
editorDataLimitMsg more items. Search to refine further.
deferLayoutUpdate Defer Layout Update
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
memberType Field Type
selectedHierarchy Parent Hierarchy
formatString Format String
expressionField Expression
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
customFormat Enter custom format string
Measure Measure
Dimension Dimension
Standard Standard
Currency Currency
Percent Percent
Custom Custom
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! You can achieve it by simply selecting the field under ‘Calculated Members’.
fieldTitle Field Name
QuarterYear Quarter Year
caption Field Caption
copy Copy
group Group
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
selectGroup Select groups
of of
removeCalculatedField Are you sure you want to delete this calculated field?
yes Yes
no No
None None

NOTE

To find the latest localization keywords of pivotview and pivotfieldlist for different languages, visit this GitHub repository.

Loading Translations

To load translation object in an application, use load function of the L10n class.

The following example demonstrates the pivot table in Deutsch culture.

ej.base.L10n.load({
        'de-DE': {
            'pivotview': {
                'grandTotal': 'Gesamtsumme',
                'total': 'Insgesamt',
                'value': 'Wert',
                'noValue': 'Kein Wert',
                'row': 'Zeile',
                'column': 'Spalte',
                'collapse': 'Zusammenbruch',
                'expand': 'Erweitern'
            },
            "pivotfieldlist": {
                'fieldList': 'Feld Liste',
                'dropRowPrompt': 'Drop Reihe hier',
                'dropColPrompt': 'Drop column Hier',
                'dropValPrompt': 'Drop wert hier',
                'dropFilterPrompt': 'Drop Filter Hier',
                'addPrompt': 'Feld hinzufügen',
                'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
                'add': 'Hinzufügen',
                'drag': 'Ziehen',
                'filters': 'Filter',
                'rows': 'Zeilen',
                'columns': 'Spalten',
                'values': 'Werte',
                'error': 'Fehler',
                'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
                'search': 'Suche',
                'close': 'Schließen',
                'cancel': 'Abbrechen',
                'delete': 'Löschen',
                'alert': 'Warnung',
                'warning': 'Warnung',
                'ok': 'OK',
                'allFields': 'Alle Felder',
                'noMatches': 'Keine Treffer',
            }
        }
    });
    ej.pivotview.PivotView.Inject(ej.pivotview.FieldList);
    var pivotTableObj = new ej.pivotview.PivotView({
        dataSourceSettings: {
            dataSource: pivotData,
            expandAll: false,
            enableSorting: true,
            drilledMembers: [{ name: 'Country', items: ['France'] }],
            columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
            values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
            rows: [{ name: 'Country' }, { name: 'Products' }],
            formatSettings: [{ name: 'Amount', format: 'C0' }],
            filters: []
        },
        locale: 'de-DE',
        showFieldList: true,
        height: 350
    });
    pivotTableObj.appendTo('#PivotTable');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Pivot Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Pivot Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-calendars/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-grids/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-charts/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-pivotview/styles/tailwind3.css" rel="stylesheet">

    <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div>
            <div id="PivotTable"></div>
        </div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Right-to-left (RTL)

RTL provides an option to switch the text direction and layout of the pivot table component from right to left. It improves the user experiences and accessibility for users who use right-to-left languages (Arabic, Farsi, Urdu, etc…). To enable RTL pivot table, set the enableRtl property to true.

ej.base.L10n.load({
        'ar-AE': {
            'pivotview': {
                'grandTotal': 'المجموع الكلى',
                'total': 'المجموع',
                'value': 'القيمة',
                'noValue': 'لا قيمة لها',
                'row': 'صف',
                'column': 'العمود',
                'collapse': 'الانهيار',
                'expand': 'توسيع'
            },
            'pivotfieldlist': {
                'fieldList': 'قائمة الحقول',
                'dropRowPrompt': 'تراجع الخلاف هنا',
                'dropColPrompt': 'انخفاض العمود هنا',
                'dropValPrompt': 'انخفاض قيمة هنا',
                'dropFilterPrompt': 'انخفاض هنا عامل التصفية',
                'addPrompt': 'اضافة حقل هنا',
                'adaptiveFieldHeader': 'اختر الحقل',
                'centerHeader': 'اسحب المجالات بين المناطق الموضحة ادناه:',
                'add': 'اضافة',
                'drag': 'اسحب',
                'filters': 'عوامل التصفية',
                'rows': 'الصفوف',
                'columns': 'الاعمدة',
                'values': 'قيم',
                'search': 'البحث',
                'close': 'قريب',
                'cancel': 'الغاء',
                'delete': 'احذف',
                'alert': 'حالة تاهب قصوى',
                'warning': 'تحذير',
                'ok': 'موافق',
                'allFields': 'جميع الحقول',
                'noMatches': 'لا مباريات'
            }
        }
    });
    ej.pivotview.PivotView.Inject(ej.pivotview.FieldList);
    var pivotTableObj = new ej.pivotview.PivotView({
        dataSourceSettings: {
            dataSource: pivotData,
            expandAll: false,
            enableSorting: true,
            drilledMembers: [{ name: 'Country', items: ['France'] }],
            columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
            values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
            rows: [{ name: 'Country' }, { name: 'Products' }],
            formatSettings: [{ name: 'Amount', format: 'C0' }],
            filters: []
        },
        enableRtl: true,
        locale: 'ar-AE',
        showFieldList: true,
        height: 350
    });
    pivotTableObj.appendTo('#PivotTable');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Pivot Grid</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Pivot Grid Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-calendars/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-dropdowns/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-grids/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-charts/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-inputs/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-lists/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-navigations/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-pivotview/styles/tailwind3.css" rel="stylesheet">

    <link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.2.2/dist/ej2.min.js" type="text/javascript"></script>
    <script src="es5-datasource.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div>
            <div id="PivotTable"></div>
        </div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

See Also

Globalization and localization in React Pivot Table

10 Aug 202624 minutes to read

The Pivot Table helps users view and interact with data in their own language and regional format. This means users from different countries can easily read and understand the data because dates, numbers, and words are shown in a way that feels familiar to them.

Globalization combines two important aspects:

Internationalization: This enables the Pivot Table to display dates and numbers based on local standards. For example, the date can appear as MM/dd/yyyy in the United States or dd/MM/yyyy in the United Kingdom.

Localization: This allows you to provide translations for text in the Pivot Table, such as button labels, menu items, and messages. You can display all these text elements in the language preferred by your users.

With both internationalization and localization, you can make sure the Pivot Table is friendly and easy to use for people who speak different languages and come from various regions.

For more details:

Load CLDR-Data to the application

Note: Modern EJ2 applications use the loadCldr method from @syncfusion/ej2-base to load CLDR JSON data from the cldr-data npm package, which simplifies the setup. The steps below describe the manual approach for legacy applications.

  • Open command prompt in your machine.

  • Run the following command in command prompt.

      cd /d 'Folder path of your react application'
    
      For example: cd /d  E:\react\WebApplication
    
  • Make sure that you have installed Node.js and npm on your machine before installing the CLDR-Data package.

  • To check if you have Node.js installed, run this command in the command prompt.

      node -v
    
  • If Node.js is not installed, then you can download and install it from the Node.js website.

  • To confirm if you have npm installed, run this command in the command prompt.

      npm -v
    
  • Now, install the CLDR-Data package by using the following command (it installs the CLDR JSON data). To learn more about CLDR-Data, refer to CLDR-Data.

      npm install cldr-data --save
    
  • After installing the package, you can find the culture-specific JSON data under the location /node_modules/cldr-data. Then, copy the cldr-data folder into your React application.

  • Download the required locale packages to render the React Pivot Table component with specified locale. To download the locale definition of React components, use this link.

  • After downloading the ej2-locale package, copy the ej2-locale folder with required locale definition file into your React application. By default, the ej2-locale package contains the localized text for static text present in components like grid, chart, Pivot Table, tools, and more.

The locale JSON file will look like:

output

Internationalization

Internationalization helps you display dates and numbers in the Pivot Table according to different cultural formats. This means users from various countries can view data in their familiar regional formats, making the component more user-friendly and accessible.

The internationalization library uses official Unicode CLDR JSON data to format and parse numbers, dates, and times. It also provides the loadCldr method to load culture-specific CLDR JSON data for your application.

By default, all Syncfusion components use English culture (‘en-US’). To use a different culture, set the culture by using the locale property as shown in the example below:

import { FieldList, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';
setCulture('de');
setCurrencyCode('EUR');
L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer'
        }
    }
});
function App() {
    let dataSourceSettings = {
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        dataSource: pivotData,
        expandAll: false,
        filters: [],
        formatSettings: [{ name: 'Amount', format: 'C2', useGrouping: false,
                minimumSignificantDigits: 1, maximumSignificantDigits: 3, currency: 'EUR' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
    };
    let pivotObj;
    return (<PivotViewComponent ref={d => pivotObj = d} id='PivotView' height={350} locale='de-DE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]}/></PivotViewComponent>);
};
export default App;
import { FieldList, IDataSet, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';
import { L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';

setCulture('de');
setCurrencyCode('EUR');

L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer'
        }
    }
});
function App() {
  let dataSourceSettings: DataSourceSettingsModel = {
    columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
    dataSource: pivotData as IDataSet[],
    expandAll: false,
    filters: [],
    formatSettings: [{ name: 'Amount', format: 'C2', useGrouping: false,
                minimumSignificantDigits: 1, maximumSignificantDigits: 3, currency: 'EUR' }],
    rows: [{ name: 'Country' }, { name: 'Products' }],
    values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
  }
  let pivotObj: PivotViewComponent;
  
  return (<PivotViewComponent  ref={ (d: PivotViewComponent) => pivotObj = d } id='PivotView' height={350} locale='de-DE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]} /></PivotViewComponent>);
};

export default App;

  • In the above sample, Amount field is formatted by NumberFormatOptions. For date formats, the value strings are formatted by DateFormatOptions.
  • By default, locale value is en-US. If you want to change the en-US culture to a different culture, you have to change the locale accordingly.
  • You can find more details about supported format strings for number formats and date formats here.

Decimal separators

The Pivot Table automatically adjusts decimal separators in numeric values to match your selected culture, making data easier to read for users from different regions. You can set the culture by calling the setCulture method with the appropriate culture string as its parameter. Once applied, all numeric values in the Pivot Table will display using the decimal separator convention of that culture.

For example, while English cultures typically use a dot (.) as the decimal separator, German culture uses a comma (,) instead.

The following example shows how decimal separators appear when using the Deutsch culture.

import { FieldList, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { loadCldr, L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';
import * as currencies from './currencies.json';
import * as cagregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
import * as numberingSystems from './numberingSystems.json';
loadCldr(currencies, cagregorian, numbers, timeZoneNames, numberingSystems);
setCulture('de');
setCurrencyCode('EUR');
L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer'
        }
    }
});
function App() {
    let dataSourceSettings = {
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        dataSource: pivotData,
        formatSettings: [{ name: 'Amount', format: 'C2', currency: 'EUR' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
    };
    let pivotObj;
    return (<PivotViewComponent ref={d => pivotObj = d} id='PivotView' height={350} locale='de-DE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]}/></PivotViewComponent>);
};
export default App;
import { FieldList, IDataSet, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';
import { loadCldr, L10n, setCulture, setCurrencyCode, Ajax } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';
import * as currencies from './currencies.json';
import * as cagregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
import * as numberingSystems from './numberingSystems.json';

loadCldr(currencies, cagregorian, numbers, timeZoneNames, numberingSystems);
setCulture('de');
setCurrencyCode('EUR');

L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer'
        }
    }
});
function App() {

  let dataSourceSettings: DataSourceSettingsModel = {
    columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
    dataSource: pivotData as IDataSet[],
    formatSettings: [{ name: 'Amount', format: 'C2', currency: 'EUR' }],
    rows: [{ name: 'Country' }, { name: 'Products' }],
    values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
  }
  let pivotObj: PivotViewComponent;
  
  return (<PivotViewComponent  ref={ (d: PivotViewComponent) => pivotObj = d } id='PivotView' height={350} locale='de-DE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]} /></PivotViewComponent>);
};

export default App;
export let pivotData = [
    { 'In_Stock': 34, 'Sold': 51, 'Amount': 383, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 4, 'Sold': 423, 'Amount': 3595.5, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Cleaners', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 11, 'Sold': 19, 'Amount': 85.5, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 10, 'Sold': 64, 'Amount': 320, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2018', 'Quarter': 'Q4' },
    { 'In_Stock': 2, 'Sold': 141, 'Amount': 1692, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 30, 'Sold': 332, 'Amount': 3735, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 9, 'Sold': 353, 'Amount': 3000.5, 'Country': 'Germany', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 32, 'Sold': 269, 'Amount': 1345, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 73, 'Amount': 1387, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Tires and Tubes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 19, 'Sold': 279, 'Amount': 205363, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Road Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 41, 'Sold': 82, 'Amount': 922.5, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 15, 'Sold': 188, 'Amount': 1457, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Teleshopping', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 78, 'Amount': 1677, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q3' },
    { 'In_Stock': 46, 'Sold': 393, 'Amount': 6681, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 35, 'Sold': 61, 'Amount': 991.25, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 34, 'Sold': 271, 'Amount': 4336, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 48, 'Sold': 361, 'Amount': 10469, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 20, 'Sold': 464, 'Amount': 13108, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 45, 'Sold': 257, 'Amount': 28784, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q4' },
    { 'In_Stock': 5, 'Sold': 333, 'Amount': 2081.25, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Gloves', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 252, 'Amount': 401940, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 38, 'Sold': 287, 'Amount': 457765, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'App Store', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 29, 'Sold': 92, 'Amount': 146786, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2018', 'Quarter': 'Q3' },
    { 'In_Stock': 14, 'Sold': 535, 'Amount': 10165, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 405, 'Amount': 3037.5, 'Country': 'United States', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
];
export let pivotData: object[] = [
    { 'In_Stock': 34, 'Sold': 51, 'Amount': 383, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 4, 'Sold': 423, 'Amount': 3595.5, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Cleaners', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 11, 'Sold': 19, 'Amount': 85.5, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 10, 'Sold': 64, 'Amount': 320, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2018', 'Quarter': 'Q4' },
    { 'In_Stock': 2, 'Sold': 141, 'Amount': 1692, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 30, 'Sold': 332, 'Amount': 3735, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 9, 'Sold': 353, 'Amount': 3000.5, 'Country': 'Germany', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 32, 'Sold': 269, 'Amount': 1345, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 73, 'Amount': 1387, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Tires and Tubes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 19, 'Sold': 279, 'Amount': 205363, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Road Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 41, 'Sold': 82, 'Amount': 922.5, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 15, 'Sold': 188, 'Amount': 1457, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Teleshopping', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 78, 'Amount': 1677, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q3' },
    { 'In_Stock': 46, 'Sold': 393, 'Amount': 6681, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 35, 'Sold': 61, 'Amount': 991.25, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 34, 'Sold': 271, 'Amount': 4336, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 48, 'Sold': 361, 'Amount': 10469, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 20, 'Sold': 464, 'Amount': 13108, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 45, 'Sold': 257, 'Amount': 28784, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q4' },
    { 'In_Stock': 5, 'Sold': 333, 'Amount': 2081.25, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Gloves', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 252, 'Amount': 401940, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 38, 'Sold': 287, 'Amount': 457765, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'App Store', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 29, 'Sold': 92, 'Amount': 146786, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2018', 'Quarter': 'Q3' },
    { 'In_Stock': 14, 'Sold': 535, 'Amount': 10165, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 405, 'Amount': 3037.5, 'Country': 'United States', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
];

Localization

The Localization option allows you to translate the default text content of the Pivot Table into different languages. This makes the component more accessible to users from various regions by displaying text in their preferred language.

The Pivot Table contains static text elements such as drop area messages, field list titles, and other interface labels that can be translated to different cultures (Arabic, German, French, etc.). You can achieve this by setting the locale property and providing the appropriate translation object.

The following table shows the locale keywords and their corresponding default text values used in the Pivot Table:

Locale keywords Text
grandTotal Grand Total
total Total
value Value
noValue No value
row Row
column Column
collapse Collapse
expand Expand
rowAxisPrompt Drop row here
columnAxisPrompt Drop column here
valueAxisPrompt Drop value here
filterAxisPrompt Drop filter here
filter Filter
filtered Filtered
sort Sort
filters Filters
rows Rows
columns Columns
values Values
close Close
cancel Cancel
delete Delete
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
alert Alert
warning Warning
ok OK
search Search
drag Drag
remove Remove
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
addToRow Add to Row
addToColumn Add to Column
addToValue Add to Value
addToFilter Add to Filter
emptyData No records to display
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
all All
multipleItems Multiple items
member Member
label Label
date Date
enterValue Enter value
chooseDate Enter date
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
And and
DistinctCount Distinct Count
Product Product
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
NotEquals Not Equals
AllValues All Values
conditionalFormatting Conditional Formatting
apply APPLY
condition Add Condition
formatLabel Format
valueFieldSettings Value field settings
baseField Base field :
baseItem Base item :
summarizeValuesBy Summarize values by :
sourceName Field name :
sourceCaption Field caption :
example e.g:
editorDataLimitMsg more items. Search to refine further.
details Details
manageRecords Manage Records
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
save Save a report
new Create a new report
load Load
saveAs Save as current report
rename Rename a current report
deleteReport Delete a current report
export Export
subTotals Sub totals
grandTotals Grand totals
reportName Report Name :
pdf PDF
excel Excel
csv CSV
png PNG
jpeg JPEG
svg SVG
mdxQuery MDX Query
showSubTotals Show subtotals
doNotShowSubTotals Do not show subtotals
showSubTotalsRowsOnly Show subtotals rows only
showSubTotalsColumnsOnly Show subtotals columns only
showGrandTotals Show grand totals
doNotShowGrandTotals Do not show grand totals
showGrandTotalsRowsOnly Show grand totals rows only
showGrandTotalsColumnsOnly Show grand totals columns only
fieldList Show fieldlist
grid Show table
toolbarFormatting Conditional formatting
chart Chart
reportMsg Please enter valid report name!!!
reportList Report list
removeConfirm Are you sure want to delete this report?
emptyReport No reports found!!
bar Bar
line Line
area Area
scatter Scatter
polar Polar
of of
emptyFormat No format found!!!
emptyInput Enter a value
newReportConfirm Want to save changes to report?
emptyReportName Enter a report name
qtr Qtr
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
aggregate Aggregate
drillThrough Drill Through
ascending Ascending
descending Descending
number Number
currency Currency
percentage Percentage
formatType Format Type
customText Currency Symbol
symbolPosition Symbol Position
left Left
right Right
grouping Grouping
true True
false False
decimalPlaces Decimal Places
numberFormat Number Formatting
memberType Field Type
formatString Format String
expressionField Expression
customFormat Enter custom format string
selectedHierarchy Parent Hierarchy
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
Percent Percent
Custom Custom
Measure Measure
Dimension Dimension
Standard Standard
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! Then you can achieve it by simply selecting the field under ‘Calculated Members’.
QuarterYear Quarter Year
fieldTitle Field Name
drillError Cannot show the raw items of calculated fields.
caption Field Caption
copy Copy
defaultReport Default report
customFormatString Custom Format
invalidFormat Invalid Format.
group Group
unGroup Ungroup
invalidSelection Cannot group that selection.
groupName Enter the caption to display in header
captionName Enter the caption for group field
selectedItems Selected items
groupFieldCaption Field caption
groupTitle Group name
startAt Starting at
endAt Ending at
groupBy Interval by
selectGroup Select groups
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
stackingcolumn Stacked Column
stackingbar Stacked Bar
stackingarea Stacked Area
stepline Step Line
steparea Step Area
splinearea Spline Area
spline Spline
stackingcolumn100 100% Stacked Column
stackingbar100 100% Stacked Bar
stackingarea100 100% Stacked Area
bubble bubble
pareto Pareto
radar Radar
chartTypeSettings Chart type settings
multipleAxes Multiple Axes
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
ChartType Chart Type
yes Yes
no No
numberFormatMenu Number Formatting…
conditionalFormattingMenu Conditional Formatting…
removeCalculatedField Are you sure you want to delete this calculated field?
replaceConfirmBefore A report named
replaceConfirmAfter already exists. Do you want to replace it?
pie Pie
funnel Funnel
doughnut Doughnut
pyramid Pyramid
showLegend Show Legend
exit Exit
invalidJSON Invalid JSON data
invalidCSV Invalid CSV data
stacked Stacked
single Single
multipleAxisMode Multiple Axis Mode
grandTotalPosition Grand totals position
top Top
bottom Bottom
None None
stackingline Stacked Line
stackingline100 100% Stacked Line
rowPage Row pager
rowPerPage Rows per page
columnPage Column pager
columnPerPage Columns per page
goToFirstPage Go to first page
goToPreviousPage Go to previous page
goToNextPage Go to next page
goToLastPage Go to last page
combined Combined
subTotalPosition Subtotals position
auto Auto

The following list of properties and its values are used in the pivot field list.

Locale keywords Text
staticFieldList Pivot Field List
fieldList Field List
dropFilterPrompt Drop filter here
dropColPrompt Drop column here
dropRowPrompt Drop row here
dropValPrompt Drop value here
addPrompt Add field here
adaptiveFieldHeader Choose field
centerHeader Drag fields between axes below:
add add
drag Drag
filter Filter
filtered Filtered
sort Sort
remove Remove
filters Filters
rows Rows
columns Columns
values Values
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
search Search
close Close
cancel Cancel
delete Delete
alert Alert
warning Warning
ok OK
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
enterValue Enter value
chooseDate Enter date
all All
multipleItems Multiple items
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
member Member
label Label
date Date
value Value
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
And and
DistinctCount Distinct Count
Product Product
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
apply APPLY
valueFieldSettings Value field settings
sourceName Field name :
sourceCaption Field caption :
summarizeValuesBy Summarize values by :
baseField Base field :
baseItem Base item :
example e.g:
editorDataLimitMsg more items. Search to refine further.
deferLayoutUpdate Defer Layout Update
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
memberType Field Type
selectedHierarchy Parent Hierarchy
formatString Format String
expressionField Expression
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
customFormat Enter custom format string
Measure Measure
Dimension Dimension
Standard Standard
Currency Currency
Percent Percent
Custom Custom
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! You can achieve it by simply selecting the field under ‘Calculated Members’.
fieldTitle Field Name
QuarterYear Quarter Year
caption Field Caption
copy Copy
group Group
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
selectGroup Select groups
of of
removeCalculatedField Are you sure you want to delete this calculated field?
yes Yes
no No
None None

NOTE

To access the most recent localization keywords for the Pivot Table and Pivot Field List components in different languages, visit the GitHub repository.

Loading Translations

To load translation content in your application, use the load method of the L10n class. This method accepts translation objects that contain text content in different languages.

The following example demonstrates the Pivot Table in Deutsch culture.

import { FieldList, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { L10n } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';
L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer'
        }
    }
});
function App() {
    let dataSourceSettings = {
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        dataSource: pivotData,
        expandAll: false,
        filters: [],
        formatSettings: [{ name: 'Amount', format: 'C0' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
    };
    let pivotObj;
    return (<PivotViewComponent ref={d => pivotObj = d} id='PivotView' height={350} locale='de-DE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]}/></PivotViewComponent>);
};
export default App;
import { FieldList, IDataSet, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';
import { L10n } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';

L10n.load({
    'de-DE': {
        'pivotview': {
            'grandTotal': 'Gesamtsumme',
            'total': 'Insgesamt',
            'value': 'Wert',
            'noValue': 'Kein Wert',
            'row': 'Zeile',
            'column': 'Spalte',
            'collapse': 'Zusammenbruch',
            'expand': 'Erweitern'
        },
        "pivotfieldlist": {
            'fieldList': 'Feld Liste',
            'dropRowPrompt': 'Drop Reihe hier',
            'dropColPrompt': 'Drop column Hier',
            'dropValPrompt': 'Drop wert hier',
            'dropFilterPrompt': 'Drop Filter Hier',
            'addPrompt': 'Feld hinzufügen',
            'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
            'add': 'Hinzufügen',
            'drag': 'Ziehen',
            'filters': 'Filter',
            'rows': 'Zeilen',
            'columns': 'Spalten',
            'values': 'Werte',
            'error': 'Fehler',
            'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
            'search': 'Suche',
            'close': 'Schließen',
            'cancel': 'Abbrechen',
            'delete': 'Löschen',
            'alert': 'Warnung',
            'warning': 'Warnung',
            'ok': 'OK',
            'allFields': 'Alle Felder',
            'noMatches': 'Keine Treffer'
        }
    }
});
function App() {
  let dataSourceSettings: DataSourceSettingsModel = {
    columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
    dataSource: pivotData as IDataSet[],
    expandAll: false,
    filters: [],
    formatSettings: [{ name: 'Amount', format: 'C0' }],
    rows: [{ name: 'Country' }, { name: 'Products' }],
    values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
  }
  let pivotObj: PivotViewComponent;
  
  return (<PivotViewComponent  ref={ (d: PivotViewComponent) => pivotObj = d } id='PivotView' height={350} locale='de-DE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]} /></PivotViewComponent>);
};

export default App;

Right-to-left (RTL)

Right-to-left (RTL) support makes the Pivot Table more accessible and user-friendly for people who read and write in right-to-left languages such as Arabic, Farsi, and Urdu. This feature adjusts the text direction and layout of the entire Pivot Table from a left-to-right to a right-to-left orientation. To enable RTL in the Pivot Table, set the enableRtl property to true.

import { FieldList, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { L10n } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';
L10n.load({
    'ar-AE': {
        'pivotview': {
            'grandTotal': 'المجموع الكلى',
            'total': 'المجموع',
            'value': 'القيمة',
            'noValue': 'لا قيمة لها',
            'row': 'صف',
            'column': 'العمود',
            'collapse': 'الانهيار',
            'expand': 'توسيع'
        },
        'pivotfieldlist': {
            'fieldList': 'قائمة الحقول',
            'dropRowPrompt': 'تراجع الخلاف هنا',
            'dropColPrompt': 'انخفاض العمود هنا',
            'dropValPrompt': 'انخفاض قيمة هنا',
            'dropFilterPrompt': 'انخفاض هنا عامل التصفية',
            'addPrompt': 'اضافة حقل هنا',
            'adaptiveFieldHeader': 'اختر الحقل',
            'centerHeader': 'اسحب المجالات بين المناطق الموضحة ادناه:',
            'add': 'اضافة',
            'drag': 'اسحب',
            'filters': 'عوامل التصفية',
            'rows': 'الصفوف',
            'columns': 'الاعمدة',
            'values': 'قيم',
            'search': 'البحث',
            'close': 'قريب',
            'cancel': 'الغاء',
            'delete': 'احذف',
            'alert': 'حالة تاهب قصوى',
            'warning': 'تحذير',
            'ok': 'موافق',
            'allFields': 'جميع الحقول',
            'noMatches': 'لا مباريات'
        }
    }
});
function App() {
    let dataSourceSettings = {
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        dataSource: pivotData,
        expandAll: false,
        filters: [],
        formatSettings: [{ name: 'Amount', format: 'C0' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
    };
    let pivotObj;
    return (<PivotViewComponent ref={d => pivotObj = d} id='PivotView' height={350} enableRtl={true} locale='ar-AE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]}/></PivotViewComponent>);
};
export default App;
import { FieldList, IDataSet, Inject, PivotViewComponent, GroupingBar, CalculatedField } from '@syncfusion/ej2-react-pivotview';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';
import { L10n } from '@syncfusion/ej2-base';
import * as React from 'react';
import { pivotData } from './datasource';

L10n.load({
  'ar-AE': {
      'pivotview': {
          'grandTotal': 'المجموع الكلى',
          'total': 'المجموع',
          'value': 'القيمة',
          'noValue': 'لا قيمة لها',
          'row': 'صف',
          'column': 'العمود',
          'collapse': 'الانهيار',
          'expand': 'توسيع'
      },
      'pivotfieldlist': {
          'fieldList': 'قائمة الحقول',
          'dropRowPrompt': 'تراجع الخلاف هنا',
          'dropColPrompt': 'انخفاض العمود هنا',
          'dropValPrompt': 'انخفاض قيمة هنا',
          'dropFilterPrompt': 'انخفاض هنا عامل التصفية',
          'addPrompt': 'اضافة حقل هنا',
          'adaptiveFieldHeader': 'اختر الحقل',
          'centerHeader': 'اسحب المجالات بين المناطق الموضحة ادناه:',
          'add': 'اضافة',
          'drag': 'اسحب',
          'filters': 'عوامل التصفية',
          'rows': 'الصفوف',
          'columns': 'الاعمدة',
          'values': 'قيم',
          'search': 'البحث',
          'close': 'قريب',
          'cancel': 'الغاء',
          'delete': 'احذف',
          'alert': 'حالة تاهب قصوى',
          'warning': 'تحذير',
          'ok': 'موافق',
          'allFields': 'جميع الحقول',
          'noMatches': 'لا مباريات'
      }
  }
});
function App() {
  let dataSourceSettings: DataSourceSettingsModel = {
    columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
    dataSource: pivotData as IDataSet[],
    expandAll: false,
    filters: [],
    formatSettings: [{ name: 'Amount', format: 'C0' }],
    rows: [{ name: 'Country' }, { name: 'Products' }],
    values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }]
  }
  let pivotObj: PivotViewComponent;
  
  return (<PivotViewComponent  ref={ (d: PivotViewComponent) => pivotObj = d } id='PivotView' height={350} enableRtl={true} locale='ar-AE' dataSourceSettings={dataSourceSettings} showFieldList={true} showGroupingBar={true} allowCalculatedField={true}><Inject services={[FieldList, GroupingBar, CalculatedField]} /></PivotViewComponent>);
};

export default App;
export let pivotData = [
    { 'In_Stock': 34, 'Sold': 51, 'Amount': 383, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 4, 'Sold': 423, 'Amount': 3595.5, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Cleaners', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 11, 'Sold': 19, 'Amount': 85.5, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 10, 'Sold': 64, 'Amount': 320, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2018', 'Quarter': 'Q4' },
    { 'In_Stock': 2, 'Sold': 141, 'Amount': 1692, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 30, 'Sold': 332, 'Amount': 3735, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 9, 'Sold': 353, 'Amount': 3000.5, 'Country': 'Germany', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 32, 'Sold': 269, 'Amount': 1345, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 73, 'Amount': 1387, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Tires and Tubes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 19, 'Sold': 279, 'Amount': 205363, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Road Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 41, 'Sold': 82, 'Amount': 922.5, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 15, 'Sold': 188, 'Amount': 1457, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Teleshopping', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 78, 'Amount': 1677, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q3' },
    { 'In_Stock': 46, 'Sold': 393, 'Amount': 6681, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 35, 'Sold': 61, 'Amount': 991.25, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 34, 'Sold': 271, 'Amount': 4336, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 48, 'Sold': 361, 'Amount': 10469, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 20, 'Sold': 464, 'Amount': 13108, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 45, 'Sold': 257, 'Amount': 28784, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q4' },
    { 'In_Stock': 5, 'Sold': 333, 'Amount': 2081.25, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Gloves', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 252, 'Amount': 401940, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 38, 'Sold': 287, 'Amount': 457765, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'App Store', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 29, 'Sold': 92, 'Amount': 146786, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2018', 'Quarter': 'Q3' },
    { 'In_Stock': 14, 'Sold': 535, 'Amount': 10165, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 405, 'Amount': 3037.5, 'Country': 'United States', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
];
export let pivotData: object[] = [
    { 'In_Stock': 34, 'Sold': 51, 'Amount': 383, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 4, 'Sold': 423, 'Amount': 3595.5, 'Country': 'France', 'Product_Categories': 'Accessories', 'Products': 'Cleaners', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 11, 'Sold': 19, 'Amount': 85.5, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 10, 'Sold': 64, 'Amount': 320, 'Country': 'France', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2018', 'Quarter': 'Q4' },
    { 'In_Stock': 2, 'Sold': 141, 'Amount': 1692, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 30, 'Sold': 332, 'Amount': 3735, 'Country': 'France', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 9, 'Sold': 353, 'Amount': 3000.5, 'Country': 'Germany', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 32, 'Sold': 269, 'Amount': 1345, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 73, 'Amount': 1387, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Tires and Tubes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 19, 'Sold': 279, 'Amount': 205363, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Road Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 41, 'Sold': 82, 'Amount': 922.5, 'Country': 'Germany', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 15, 'Sold': 188, 'Amount': 1457, 'Country': 'Germany', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Teleshopping', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 31, 'Sold': 78, 'Amount': 1677, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2015', 'Quarter': 'Q3' },
    { 'In_Stock': 46, 'Sold': 393, 'Amount': 6681, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'Sales Person', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 35, 'Sold': 61, 'Amount': 991.25, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 34, 'Sold': 271, 'Amount': 4336, 'Country': 'United Kingdom', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 48, 'Sold': 361, 'Amount': 10469, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Shorts', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q1' },
    { 'In_Stock': 20, 'Sold': 464, 'Amount': 13108, 'Country': 'United Kingdom', 'Product_Categories': 'Clothing', 'Products': 'Jerseys', 'Order_Source': 'Teleshopping', 'Year': 'FY 2017', 'Quarter': 'Q1' },
    { 'In_Stock': 45, 'Sold': 257, 'Amount': 28784, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Vests', 'Order_Source': 'Sales Person', 'Year': 'FY 2015', 'Quarter': 'Q4' },
    { 'In_Stock': 5, 'Sold': 333, 'Amount': 2081.25, 'Country': 'United States', 'Product_Categories': 'Clothing', 'Products': 'Gloves', 'Order_Source': 'Teleshopping', 'Year': 'FY 2016', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 252, 'Amount': 401940, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Helmets', 'Order_Source': 'App Store', 'Year': 'FY 2018', 'Quarter': 'Q1' },
    { 'In_Stock': 38, 'Sold': 287, 'Amount': 457765, 'Country': 'United Kingdom', 'Product_Categories': 'Accessories', 'Products': 'Fenders', 'Order_Source': 'App Store', 'Year': 'FY 2016', 'Quarter': 'Q3' },
    { 'In_Stock': 29, 'Sold': 92, 'Amount': 146786, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Touring Bikes', 'Order_Source': 'Retail Outlets', 'Year': 'FY 2018', 'Quarter': 'Q3' },
    { 'In_Stock': 14, 'Sold': 535, 'Amount': 10165, 'Country': 'United States', 'Product_Categories': 'Bikes', 'Products': 'Mountain Bikes', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
    { 'In_Stock': 47, 'Sold': 405, 'Amount': 3037.5, 'Country': 'United States', 'Product_Categories': 'Accessories', 'Products': 'Bottles and Cages', 'Order_Source': 'App Store', 'Year': 'FY 2017', 'Quarter': 'Q4' },
];

See Also

Globalization in Vue Pivot Table

7 Aug 202624 minutes to read

Globalization is the combination of Internationalization and localization. You can adapt the component to various languages by parsing and formatting the date or number (Internationalization) & adding culture specific customization and translation to the text (Localization).

Internationalization

Internationalization library provides support for formatting and parsing the number, date, and time by using the official Unicode CLDR JSON data and also provides the loadCldr method to load the culture specific CLDR JSON data.

By default, all the Essential® JS 2 component are specific to English culture (‘en-US’). If you want to go with the different culture other than English, follow the below steps.

  • Install the CLDR-Data package by using the below command (it installs the CLDR JSON data). For more information about CLDR-Data, refer to this link.

      npm install cldr-data --save
    

Once the package installed, you can find the culture specific JSON data under the location /node_modules/cldr-data.

  • Now import the installed CLDR JSON data into the App.vue file. To import JSON data we need to install the JSON plugin loader. Here we have used the SystemJS JSON plugin loader.

      npm install systemjs-plugin-json --save-dev
    
  • Once installed, configure the system.config.js configuration settings as like below to map the
    systemjs-plugin-json loader.

      System.config({
          paths: {
              'syncfusion:': './node_modules/@syncfusion/'
          },
          map: {
              app: 'app',
    
              //Syncfusion packages mapping
              "@syncfusion/ej2-base": "syncfusion:ej2-base/dist/ej2-base.umd.min.js",
              "@syncfusion/ej2-data": "syncfusion:ej2-data/dist/ej2-data.umd.min.js",
              "@syncfusion/ej2-inputs": "syncfusion:ej2-inputs/dist/ej2-inputs.umd.min.js",
              "@syncfusion/ej2-buttons": "syncfusion:ej2-buttons/dist/ej2-buttons.umd.min.js",
              "@syncfusion/ej2-splitbuttons": "syncfusion:ej2-splitbuttons/dist/ej2-splitbuttons.umd.min.js",
              "@syncfusion/ej2-popups": "syncfusion:ej2-popups/dist/ej2-popups.umd.min.js",
              "@syncfusion/ej2-navigations": "syncfusion:ej2-navigations/dist/ej2-navigations.umd.min.js",
              "@syncfusion/ej2-grids": "syncfusion:ej2-grids/dist/ej2-grids.umd.min.js",
              "@syncfusion/ej2-dropdowns": "syncfusion:ej2-dropdowns/dist/ej2-dropdowns.umd.min.js",
              "@syncfusion/ej2-calendars": "syncfusion:ej2-calendars/dist/ej2-calendars.umd.min.js",
              "@syncfusion/ej2-lists": "syncfusion:ej2-lists/dist/ej2-lists.umd.min.js",
              "@syncfusion/ej2-excel-export": "syncfusion:ej2-excel-export/dist/ej2-excel-export.umd.min.js",
              "@syncfusion/ej2-pdf-export": "syncfusion:ej2-pdf-export/dist/ej2-pdf-export.umd.min.js",
              "@syncfusion/ej2-file-utils": "syncfusion:ej2-file-utils/dist/ej2-file-utils.umd.min.js",
              "@syncfusion/ej2-compression": "syncfusion:ej2-compression/dist/ej2-compression.umd.min.js",
              "@syncfusion/ej2-pivotview": "syncfusion:ej2-pivotview/dist/ej2-pivotview.umd.min.js",
              "@syncfusion/ej2-vue-base": "syncfusion:ej2-vue-base/dist/ej2-vue-base.umd.min.js",
              "@syncfusion/ej2-vue-pivotview": "syncfusion:ej2-vue-pivotview/dist/ej2-vue-pivotview.umd.min.js",
              "@syncfusion/ej2-vue-buttons": "syncfusion:ej2-vue-buttons/dist/ej2-vue-buttons.umd.min.js",
          },
          meta: {
              '*.json': { loader: 'plugin-json' }
          },
          packages: {
              'app': { main: 'app', defaultExtension: 'js' },
              'cldr-data': { main: 'index.js', defaultExtension: 'js' }
          }
      });
    
      System.import('app');
  • Now import the required culture from the installed location to App.vue file, like the below code snippets.

      //import the loadCldr from ej2-base
      import { loadCldr} from '@syncfusion/ej2-base';
    
      loadCldr(
          require('cldr-data/supplemental/numberingSystems.json'),
          require('cldr-data/main/fr-CH/ca-gregorian.json'),
          require('cldr-data/main/fr-CH/numbers.json'));
          require('cldr-data/main/fr-CH/timeZoneNames.json'));

The Internationalization library is used to globalize number, date, and time values in pivot table component using the dataSourceSettings.formatSettings option.

  • Set the culture by using the locale property.
<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale"> </ejs-pivotview>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { loadCldr, L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as currencies from './currencies.json';
import * as cagregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
import * as numberingSystems from './numberingSystems.json';
import { PivotViewComponent as EjsPivotview, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

loadCldr(currencies, cagregorian, numbers, timeZoneNames, numberingSystems);

setCulture('de');
setCurrencyCode('EUR');

L10n.load({
  'de-DE': {
    'pivotview': {
      'grandTotal': 'Gesamtsumme',
      'total': 'Insgesamt',
      'value': 'Wert',
      'noValue': 'Kein Wert',
      'row': 'Zeile',
      'column': 'Spalte',
      'collapse': 'Zusammenbruch',
      'expand': 'Erweitern'
    },
    "pivotfieldlist": {
      'fieldList': 'Feld Liste',
      'dropRowPrompt': 'Drop Reihe hier',
      'dropColPrompt': 'Drop column Hier',
      'dropValPrompt': 'Drop wert hier',
      'dropFilterPrompt': 'Drop Filter Hier',
      'addPrompt': 'Feld hinzufügen',
      'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
      'add': 'Hinzufügen',
      'drag': 'Ziehen',
      'filters': 'Filter',
      'rows': 'Zeilen',
      'columns': 'Spalten',
      'values': 'Werte',
      'error': 'Fehler',
      'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
      'search': 'Suche',
      'close': 'Schließen',
      'cancel': 'Abbrechen',
      'delete': 'Löschen',
      'alert': 'Warnung',
      'warning': 'Warnung',
      'ok': 'OK',
      'allFields': 'Alle Felder',
      'noMatches': 'Keine Treffer'
    }
  }
});

const dataSourceSettings = {
  dataSource: pivotData,
  expandAll: false,
  drilledMembers: [{ name: 'Country', items: ['France'] }],
  filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
  columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
  values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
  rows: [{ name: 'Country' }, { name: 'Products' }],
  formatSettings: [{
    name: 'Amount', format: 'C2', useGrouping: false,
    minimumSignificantDigits: 1, maximumSignificantDigits: 3, currency: 'EUR'
  }],
  filters: []
};
const height = 350;
const showFieldList = true;
const locale = 'de-DE';

provide('pivotview', [FieldList]);

</script>
<style>@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";</style>
<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale"> </ejs-pivotview>
  </div>
</template>
<script>
import { loadCldr, L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as currencies from './currencies.json';
import * as cagregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
import * as numberingSystems from './numberingSystems.json';
import { PivotViewComponent, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

loadCldr(currencies, cagregorian, numbers, timeZoneNames, numberingSystems);

setCulture('de');
setCurrencyCode('EUR');

L10n.load({
  'de-DE': {
    'pivotview': {
      'grandTotal': 'Gesamtsumme',
      'total': 'Insgesamt',
      'value': 'Wert',
      'noValue': 'Kein Wert',
      'row': 'Zeile',
      'column': 'Spalte',
      'collapse': 'Zusammenbruch',
      'expand': 'Erweitern'
    },
    "pivotfieldlist": {
      'fieldList': 'Feld Liste',
      'dropRowPrompt': 'Drop Reihe hier',
      'dropColPrompt': 'Drop column Hier',
      'dropValPrompt': 'Drop wert hier',
      'dropFilterPrompt': 'Drop Filter Hier',
      'addPrompt': 'Feld hinzufügen',
      'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
      'add': 'Hinzufügen',
      'drag': 'Ziehen',
      'filters': 'Filter',
      'rows': 'Zeilen',
      'columns': 'Spalten',
      'values': 'Werte',
      'error': 'Fehler',
      'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
      'search': 'Suche',
      'close': 'Schließen',
      'cancel': 'Abbrechen',
      'delete': 'Löschen',
      'alert': 'Warnung',
      'warning': 'Warnung',
      'ok': 'OK',
      'allFields': 'Alle Felder',
      'noMatches': 'Keine Treffer'
    }
  }
});

export default {
  name: "App",
  components: {
    "ejs-pivotview": PivotViewComponent
  },
  data() {
    return {
      dataSourceSettings: {
        dataSource: pivotData,
        expandAll: false,
        drilledMembers: [{ name: 'Country', items: ['France'] }],
        filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        formatSettings: [{
          name: 'Amount', format: 'C2', useGrouping: false,
          minimumSignificantDigits: 1, maximumSignificantDigits: 3, currency: 'EUR'
        }],
        filters: []
      },
      height: 350,
      showFieldList: true,
      locale: 'de-DE'
    }
  },
  provide: {
    pivotview: [FieldList]
  }
}
</script>
<style>@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";</style>
<button class="preview-sample-button" id="PreviewSampleButton-024y9991n3727jn87bpadex868q6mfdq" onclick="LoadPreviewSample('https://ej2.syncfusion.com/vue/documentation/code-snippet/pivot-grid/default-cs95',this.id);">Preview Sample</button><button class="stackblitz-button" id="StackBlitzButton-024y9991n3727jn87bpadex868q6mfdq" onclick="OpenSampleInStackBlitz('https://ej2.syncfusion.com/vue/documentation/code-snippet/pivot-grid/default-cs95');"><img class="stackblitz-icon" src="https://cdn.syncfusion.com/documentation/images/StackBlitz-icon.png" alt="Stackblitz Support"/><span class="stackblitz-text">Open in Stackblitz</span></button>
  • In the above sample, Amount field is formatted by NumberFormatOptions. For date formats, the value strings are formatted by DateFormatOptions.
  • By default, locale value is en-US. If you want to change the en-US culture to a different culture, you have to change the locale accordingly.
  • Also, you will find more details about support format string for number formats and data formats here.

Decimal separators

The decimal separators of pivot table values varies based on the culture applied to the component. The culture can be set by calling the method setCulture with appropriate culture string as its parameter.

The following example demonstrates the decimal separators in Deutsch culture.

<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale"> </ejs-pivotview>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { loadCldr, L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as currencies from './currencies.json';
import * as cagregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
import * as numberingSystems from './numberingSystems.json';
import { PivotViewComponent as EjsPivotview, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

loadCldr(currencies, cagregorian, numbers, timeZoneNames, numberingSystems);
setCulture('de');
setCurrencyCode('EUR');

L10n.load({
  'de-DE': {
    'pivotview': {
      'grandTotal': 'Gesamtsumme',
      'total': 'Insgesamt',
      'value': 'Wert',
      'noValue': 'Kein Wert',
      'row': 'Zeile',
      'column': 'Spalte',
      'collapse': 'Zusammenbruch',
      'expand': 'Erweitern'
    },
    "pivotfieldlist": {
      'fieldList': 'Feld Liste',
      'dropRowPrompt': 'Drop Reihe hier',
      'dropColPrompt': 'Drop column Hier',
      'dropValPrompt': 'Drop wert hier',
      'dropFilterPrompt': 'Drop Filter Hier',
      'addPrompt': 'Feld hinzufügen',
      'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
      'add': 'Hinzufügen',
      'drag': 'Ziehen',
      'filters': 'Filter',
      'rows': 'Zeilen',
      'columns': 'Spalten',
      'values': 'Werte',
      'error': 'Fehler',
      'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
      'search': 'Suche',
      'close': 'Schließen',
      'cancel': 'Abbrechen',
      'delete': 'Löschen',
      'alert': 'Warnung',
      'warning': 'Warnung',
      'ok': 'OK',
      'allFields': 'Alle Felder',
      'noMatches': 'Keine Treffer'
    }
  }
});

const dataSourceSettings = {
  dataSource: pivotData,
  drilledMembers: [{ name: 'Country', items: ['France'] }],
  filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
  columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
  values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
  rows: [{ name: 'Country' }, { name: 'Products' }],
  formatSettings: [{ name: 'Amount', format: 'C2', currency: 'EUR' }],
  filters: []
};
const height = 350;
const showFieldList = true;
const locale = 'de-DE';

provide('pivotview', [FieldList]);

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale"> </ejs-pivotview>
  </div>
</template>
<script>
import { loadCldr, L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import * as currencies from './currencies.json';
import * as cagregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
import * as numberingSystems from './numberingSystems.json';
import { PivotViewComponent, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

loadCldr(currencies, cagregorian, numbers, timeZoneNames, numberingSystems);
setCulture('de');
setCurrencyCode('EUR');

L10n.load({
  'de-DE': {
    'pivotview': {
      'grandTotal': 'Gesamtsumme',
      'total': 'Insgesamt',
      'value': 'Wert',
      'noValue': 'Kein Wert',
      'row': 'Zeile',
      'column': 'Spalte',
      'collapse': 'Zusammenbruch',
      'expand': 'Erweitern'
    },
    "pivotfieldlist": {
      'fieldList': 'Feld Liste',
      'dropRowPrompt': 'Drop Reihe hier',
      'dropColPrompt': 'Drop column Hier',
      'dropValPrompt': 'Drop wert hier',
      'dropFilterPrompt': 'Drop Filter Hier',
      'addPrompt': 'Feld hinzufügen',
      'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
      'add': 'Hinzufügen',
      'drag': 'Ziehen',
      'filters': 'Filter',
      'rows': 'Zeilen',
      'columns': 'Spalten',
      'values': 'Werte',
      'error': 'Fehler',
      'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
      'search': 'Suche',
      'close': 'Schließen',
      'cancel': 'Abbrechen',
      'delete': 'Löschen',
      'alert': 'Warnung',
      'warning': 'Warnung',
      'ok': 'OK',
      'allFields': 'Alle Felder',
      'noMatches': 'Keine Treffer'
    }
  }
});

export default {
  name: "App",
  components: {
    "ejs-pivotview": PivotViewComponent
  },
  data() {
    return {
      dataSourceSettings: {
        dataSource: pivotData,
        drilledMembers: [{ name: 'Country', items: ['France'] }],
        filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        formatSettings: [{ name: 'Amount', format: 'C2', currency: 'EUR' }],
        filters: []
      },
      height: 350,
      showFieldList: true,
      locale: 'de-DE'
    }
  },
  provide: {
    pivotview: [FieldList]
  },
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";
</style>

Localization

The Localization library allows you to localize default text content of the pivot table. The pivot table component has static text on some features (like drop area text, pivot field list title, etc…) that can be changed to other cultures (Arabic, Deutsch, French, etc.) by defining the
locale value and translation object.

The following list of properties and its values are used in the pivot table.

Locale keywords Text
grandTotal Grand Total
total Total
value Value
noValue No value
row Row
column Column
collapse Collapse
expand Expand
rowAxisPrompt Drop row here
columnAxisPrompt Drop column here
valueAxisPrompt Drop value here
filterAxisPrompt Drop filter here
filter Filter
filtered Filtered
sort Sort
filters Filters
rows Rows
columns Columns
values Values
close Close
cancel Cancel
delete Delete
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
alert Alert
warning Warning
ok OK
search Search
drag Drag
remove Remove
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
addToRow Add to Row
addToColumn Add to Column
addToValue Add to Value
addToFilter Add to Filter
emptyData No records to display
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
all All
multipleItems Multiple items
member Member
label Label
date Date
enterValue Enter value
chooseDate Enter date
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
And and
DistinctCount Distinct Count
Product Product
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
NotEquals Not Equals
AllValues All Values
conditionalFormatting Conditional Formatting
apply APPLY
condition Add Condition
formatLabel Format
valueFieldSettings Value field settings
baseField Base field :
baseItem Base item :
summarizeValuesBy Summarize values by :
sourceName Field name :
sourceCaption Field caption :
example e.g:
editorDataLimitMsg more items. Search to refine further.
details Details
manageRecords Manage Records
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
save Save a report
new Create a new report
load Load
saveAs Save as current report
rename Rename a current report
deleteReport Delete a current report
export Export
subTotals Sub totals
grandTotals Grand totals
reportName Report Name :
pdf PDF
excel Excel
csv CSV
png PNG
jpeg JPEG
svg SVG
mdxQuery MDX Query
showSubTotals Show subtotals
doNotShowSubTotals Do not show subtotals
showSubTotalsRowsOnly Show subtotals rows only
showSubTotalsColumnsOnly Show subtotals columns only
showGrandTotals Show grand totals
doNotShowGrandTotals Do not show grand totals
showGrandTotalsRowsOnly Show grand totals rows only
showGrandTotalsColumnsOnly Show grand totals columns only
fieldList Show fieldlist
grid Show table
toolbarFormatting Conditional formatting
chart Chart
reportMsg Please enter valid report name!!!
reportList Report list
removeConfirm Are you sure want to delete this report?
emptyReport No reports found!!
bar Bar
line Line
area Area
scatter Scatter
polar Polar
of of
emptyFormat No format found!!!
emptyInput Enter a value
newReportConfirm Want to save changes to report?
emptyReportName Enter a report name
qtr Qtr
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
aggregate Aggregate
drillThrough Drill Through
ascending Ascending
descending Descending
number Number
currency Currency
percentage Percentage
formatType Format Type
customText Currency Symbol
symbolPosition Symbol Position
left Left
right Right
grouping Grouping
true True
false False
decimalPlaces Decimal Places
numberFormat Number Formatting
memberType Field Type
formatString Format String
expressionField Expression
customFormat Enter custom format string
selectedHierarchy Parent Hierarchy
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
Percent Percent
Custom Custom
Measure Measure
Dimension Dimension
Standard Standard
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! Then you can achieve it by simply selecting the field under ‘Calculated Members’.
QuarterYear Quarter Year
fieldTitle Field Name
drillError Cannot show the raw items of calculated fields.
caption Field Caption
copy Copy
defaultReport Default report
customFormatString Custom Format
invalidFormat Invalid Format.
group Group
unGroup Ungroup
invalidSelection Cannot group that selection.
groupName Enter the caption to display in header
captionName Enter the caption for group field
selectedItems Selected items
groupFieldCaption Field caption
groupTitle Group name
startAt Starting at
endAt Ending at
groupBy Interval by
selectGroup Select groups
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
stackingcolumn Stacked Column
stackingbar Stacked Bar
stackingarea Stacked Area
stepline Step Line
steparea Step Area
splinearea Spline Area
spline Spline
stackingcolumn100 100% Stacked Column
stackingbar100 100% Stacked Bar
stackingarea100 100% Stacked Area
bubble bubble
pareto Pareto
radar Radar
chartTypeSettings Chart type settings
multipleAxes Multiple Axes
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
ChartType Chart Type
yes Yes
no No
numberFormatMenu Number Formatting…
conditionalFormattingMenu Conditional Formatting…
removeCalculatedField Are you sure you want to delete this calculated field?
replaceConfirmBefore A report named
replaceConfirmAfter already exists. Do you want to replace it?
pie Pie
funnel Funnel
doughnut Doughnut
pyramid Pyramid
showLegend Show Legend
exit Exit
invalidJSON Invalid JSON data
invalidCSV Invalid CSV data
stacked Stacked
single Single
multipleAxisMode Multiple Axis Mode
grandTotalPosition Grand totals position
top Top
bottom Bottom
None None
stackingline Stacked Line
stackingline100 100% Stacked Line
rowPage Row pager
rowPerPage Rows per page
columnPage Column pager
columnPerPage Columns per page
goToFirstPage Go to first page
goToPreviousPage Go to previous page
goToNextPage Go to next page
goToLastPage Go to last page
combined Combined
subTotalPosition Subtotals position
auto Auto

The following list of properties and its values are used in the pivot field list.

Locale keywords Text
staticFieldList Pivot Field List
fieldList Field List
dropFilterPrompt Drop filter here
dropColPrompt Drop column here
dropRowPrompt Drop row here
dropValPrompt Drop value here
addPrompt Add field here
adaptiveFieldHeader Choose field
centerHeader Drag fields between axes below:
add add
drag Drag
filter Filter
filtered Filtered
sort Sort
remove Remove
filters Filters
rows Rows
columns Columns
values Values
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
search Search
close Close
cancel Cancel
delete Delete
alert Alert
warning Warning
ok OK
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
enterValue Enter value
chooseDate Enter date
all All
multipleItems Multiple items
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
member Member
label Label
date Date
value Value
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
And and
DistinctCount Distinct Count
Product Product
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
apply APPLY
valueFieldSettings Value field settings
sourceName Field name :
sourceCaption Field caption :
summarizeValuesBy Summarize values by :
baseField Base field :
baseItem Base item :
example e.g:
editorDataLimitMsg more items. Search to refine further.
deferLayoutUpdate Defer Layout Update
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
memberType Field Type
selectedHierarchy Parent Hierarchy
formatString Format String
expressionField Expression
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
customFormat Enter custom format string
Measure Measure
Dimension Dimension
Standard Standard
Currency Currency
Percent Percent
Custom Custom
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! You can achieve it by simply selecting the field under ‘Calculated Members’.
fieldTitle Field Name
QuarterYear Quarter Year
caption Field Caption
copy Copy
group Group
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
selectGroup Select groups
of of
removeCalculatedField Are you sure you want to delete this calculated field?
yes Yes
no No
None None

NOTE

To find the latest localization keywords of pivotview and pivotfieldlist for different languages, visit this GitHub repository.

Loading Translations

To load translation object in an application, use load function of the L10n class.

The following example demonstrates the pivot table in Deutsch culture.

<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale"> </ejs-pivotview>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { L10n } from '@syncfusion/ej2-base';
import { PivotViewComponent as EjsPivotview, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

L10n.load({
  'de-DE': {
    'pivotview': {
      'grandTotal': 'Gesamtsumme',
      'total': 'Insgesamt',
      'value': 'Wert',
      'noValue': 'Kein Wert',
      'row': 'Zeile',
      'column': 'Spalte',
      'collapse': 'Zusammenbruch',
      'expand': 'Erweitern'
    },
    "pivotfieldlist": {
      'fieldList': 'Feld Liste',
      'dropRowPrompt': 'Drop Reihe hier',
      'dropColPrompt': 'Drop column Hier',
      'dropValPrompt': 'Drop wert hier',
      'dropFilterPrompt': 'Drop Filter Hier',
      'addPrompt': 'Feld hinzufügen',
      'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
      'add': 'Hinzufügen',
      'drag': 'Ziehen',
      'filters': 'Filter',
      'rows': 'Zeilen',
      'columns': 'Spalten',
      'values': 'Werte',
      'error': 'Fehler',
      'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
      'search': 'Suche',
      'close': 'Schließen',
      'cancel': 'Abbrechen',
      'delete': 'Löschen',
      'alert': 'Warnung',
      'warning': 'Warnung',
      'ok': 'OK',
      'allFields': 'Alle Felder',
      'noMatches': 'Keine Treffer'
    }
  }
});

const dataSourceSettings = {
  dataSource: pivotData,
  expandAll: false,
  drilledMembers: [{ name: 'Country', items: ['France'] }],
  filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
  columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
  values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
  rows: [{ name: 'Country' }, { name: 'Products' }],
  formatSettings: [{ name: 'Amount', format: 'C0' }],
  filters: []
};
const height = 350;
const showFieldList = true;
const locale = 'de-DE';

provide('pivotview', [FieldList]);

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale"> </ejs-pivotview>
  </div>
</template>
<script>
import { L10n } from '@syncfusion/ej2-base';
import { PivotViewComponent, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

L10n.load({
  'de-DE': {
    'pivotview': {
      'grandTotal': 'Gesamtsumme',
      'total': 'Insgesamt',
      'value': 'Wert',
      'noValue': 'Kein Wert',
      'row': 'Zeile',
      'column': 'Spalte',
      'collapse': 'Zusammenbruch',
      'expand': 'Erweitern'
    },
    "pivotfieldlist": {
      'fieldList': 'Feld Liste',
      'dropRowPrompt': 'Drop Reihe hier',
      'dropColPrompt': 'Drop column Hier',
      'dropValPrompt': 'Drop wert hier',
      'dropFilterPrompt': 'Drop Filter Hier',
      'addPrompt': 'Feld hinzufügen',
      'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
      'add': 'Hinzufügen',
      'drag': 'Ziehen',
      'filters': 'Filter',
      'rows': 'Zeilen',
      'columns': 'Spalten',
      'values': 'Werte',
      'error': 'Fehler',
      'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
      'search': 'Suche',
      'close': 'Schließen',
      'cancel': 'Abbrechen',
      'delete': 'Löschen',
      'alert': 'Warnung',
      'warning': 'Warnung',
      'ok': 'OK',
      'allFields': 'Alle Felder',
      'noMatches': 'Keine Treffer'
    }
  }
});

export default {
  name: "App",
  components: {
    "ejs-pivotview": PivotViewComponent
  },
  data() {
    return {
      dataSourceSettings: {
        dataSource: pivotData,
        expandAll: false,
        drilledMembers: [{ name: 'Country', items: ['France'] }],
        filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        formatSettings: [{ name: 'Amount', format: 'C0' }],
        filters: []
      },
      height: 350,
      showFieldList: true,
      locale: 'de-DE'
    }
  },
  provide: {
    pivotview: [FieldList]
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";
</style>

Right-to-left (RTL)

RTL provides an option to switch the text direction and layout of the pivot table component from right to left. It improves the user experiences and accessibility for users who use right-to-left languages (Arabic, Farsi, Urdu, etc…). To enable RTL pivot table, set the enableRtl property to true.

<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale" :enableRtl="enableRtl"> </ejs-pivotview>
  </div>
</template>
<script setup>
import { provide } from "vue";
import { L10n } from '@syncfusion/ej2-base';
import { PivotViewComponent as EjsPivotview, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

L10n.load({
  'ar-AE': {
    'pivotview': {
      'grandTotal': 'المجموع الكلى',
      'total': 'المجموع',
      'value': 'القيمة',
      'noValue': 'لا قيمة لها',
      'row': 'صف',
      'column': 'العمود',
      'collapse': 'الانهيار',
      'expand': 'توسيع'
    },
    'pivotfieldlist': {
      'fieldList': 'قائمة الحقول',
      'dropRowPrompt': 'تراجع الخلاف هنا',
      'dropColPrompt': 'انخفاض العمود هنا',
      'dropValPrompt': 'انخفاض قيمة هنا',
      'dropFilterPrompt': 'انخفاض هنا عامل التصفية',
      'addPrompt': 'اضافة حقل هنا',
      'adaptiveFieldHeader': 'اختر الحقل',
      'centerHeader': 'اسحب المجالات بين المناطق الموضحة ادناه:',
      'add': 'اضافة',
      'drag': 'اسحب',
      'filters': 'عوامل التصفية',
      'rows': 'الصفوف',
      'columns': 'الاعمدة',
      'values': 'قيم',
      'search': 'البحث',
      'close': 'قريب',
      'cancel': 'الغاء',
      'delete': 'احذف',
      'alert': 'حالة تاهب قصوى',
      'warning': 'تحذير',
      'ok': 'موافق',
      'allFields': 'جميع الحقول',
      'noMatches': 'لا مباريات'
    }
  }
});

const dataSourceSettings = {
  dataSource: pivotData,
  expandAll: false,
  drilledMembers: [{ name: 'Country', items: ['France'] }],
  filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
  columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
  values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
  rows: [{ name: 'Country' }, { name: 'Products' }],
  formatSettings: [{ name: 'Amount', format: 'C0' }],
  filters: []
};
const height = 350;
const showFieldList = true;
const locale = 'ar-AE';
const enableRtl = true;

provide('pivotview', [FieldList]);

</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-pivotview :dataSourceSettings="dataSourceSettings" :height="height" :showFieldList="showFieldList"
      :locale="locale" :enableRtl="enableRtl"> </ejs-pivotview>
  </div>
</template>
<script>
import { L10n } from '@syncfusion/ej2-base';
import { PivotViewComponent, FieldList } from "@syncfusion/ej2-vue-pivotview";
import { pivotData } from './pivotData.js';

L10n.load({
  'ar-AE': {
    'pivotview': {
      'grandTotal': 'المجموع الكلى',
      'total': 'المجموع',
      'value': 'القيمة',
      'noValue': 'لا قيمة لها',
      'row': 'صف',
      'column': 'العمود',
      'collapse': 'الانهيار',
      'expand': 'توسيع'
    },
    'pivotfieldlist': {
      'fieldList': 'قائمة الحقول',
      'dropRowPrompt': 'تراجع الخلاف هنا',
      'dropColPrompt': 'انخفاض العمود هنا',
      'dropValPrompt': 'انخفاض قيمة هنا',
      'dropFilterPrompt': 'انخفاض هنا عامل التصفية',
      'addPrompt': 'اضافة حقل هنا',
      'adaptiveFieldHeader': 'اختر الحقل',
      'centerHeader': 'اسحب المجالات بين المناطق الموضحة ادناه:',
      'add': 'اضافة',
      'drag': 'اسحب',
      'filters': 'عوامل التصفية',
      'rows': 'الصفوف',
      'columns': 'الاعمدة',
      'values': 'قيم',
      'search': 'البحث',
      'close': 'قريب',
      'cancel': 'الغاء',
      'delete': 'احذف',
      'alert': 'حالة تاهب قصوى',
      'warning': 'تحذير',
      'ok': 'موافق',
      'allFields': 'جميع الحقول',
      'noMatches': 'لا مباريات'
    }
  }
});

export default {
  name: "App",
  components: {
    "ejs-pivotview": PivotViewComponent
  },
  data() {
    return {
      dataSourceSettings: {
        dataSource: pivotData,
        expandAll: false,
        drilledMembers: [{ name: 'Country', items: ['France'] }],
        filterSettings: [{ name: 'Country', type: 'exclude', items: ['United States'] }],
        columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
        values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
        rows: [{ name: 'Country' }, { name: 'Products' }],
        formatSettings: [{ name: 'Amount', format: 'C0' }],
        filters: []
      },
      height: 350,
      showFieldList: true,
      locale: 'ar-AE',
      enableRtl: true
    }
  },
  provide: {
    pivotview: [FieldList]
  }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-vue-pivotview/styles/tailwind3.css";
</style>

See Also

Globalization and Localization in Angular Pivot Table

6 Aug 202624 minutes to read

The Pivot Table helps users view and interact with data in their own language and regional format. This means users from different countries can easily read and understand the data because dates, numbers, and words are shown in a way that feels familiar to them.

Globalization combines two important aspects:

Internationalization: This enables the Pivot Table to display dates and numbers based on local standards. For example, the date can appear as MM/dd/yyyy in the United States or dd/MM/yyyy in the United Kingdom.

Localization: This allows you to provide translations for text in the Pivot Table, such as button labels, menu items, and messages. You can display all these text elements in the language preferred by your users.

With both internationalization and localization, you can make sure the Pivot Table is friendly and easy to use for people who speak different languages and come from various regions.

For more details:

Internationalization

Internationalization helps you display dates and numbers in the Pivot Table according to different cultural formats. This means users from various countries can view data in their familiar regional formats, making the component more user-friendly and accessible.

The internationalization library uses official Unicode CLDR JSON data to format and parse numbers, dates, and times. It also provides the loadCldr method to load culture-specific CLDR JSON data for your application.

By default, all Syncfusion components use English culture (‘en-US’). To use a different culture, follow these steps:

Step 1: install CLDR data package

Install the CLDR-Data package using the following command to get the CLDR JSON data:

npm install cldr-data --save

After installation, you can find culture-specific JSON data in the /node_modules/cldr-data location. For more information about CLDR-Data, visit this link.

Step 2: download locale packages

Download the required locale packages to render the Angular Pivot Table component with your chosen locale. You can get the locale definitions for Angular components from this link.

Step 3: import required culture data

Import the necessary culture data from the installed location to your app.component.ts file, as shown in the code example below:

//import the loadCldr from ej2-base
import { loadCldr} from '@syncfusion/ej2-base';

loadCldr(
  require('cldr-data/supplemental/numberingSystems.json'),
  require('cldr-data/main/fr-CH/ca-gregorian.json'),
  require('cldr-data/main/fr-CH/numbers.json'),
  require('cldr-data/main/fr-CH/timeZoneNames.json'));

The internationalization library helps format number, date, and time values in the Pivot Table component using the formatSettings property in dataSourceSettings configuration.

Step 4: set the culture

Set the culture by using the locale property as shown in the example below:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { PivotViewAllModule, PivotFieldListAllModule } from '@syncfusion/ej2-angular-pivotview'



import { Component } from '@angular/core';
import { L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import { IDataSet, FieldListService, CalculatedFieldService, GroupingBarService } from '@syncfusion/ej2-angular-pivotview';
import { Pivot_Data } from './datasource';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';

setCulture('de');
setCurrencyCode('EUR');

@Component({
imports: [
        
        PivotViewAllModule,
        PivotFieldListAllModule
    ],


standalone: true,
  selector: 'app-container',
  providers: [FieldListService, CalculatedFieldService, GroupingBarService],
  // specifies the template string for the pivot table component
  template: `<div style="height: 480px;"><ejs-pivotview #pivotview id='PivotView' height='350' [dataSourceSettings]=dataSourceSettings [width]=width
  allowCalculatedField='true' showGroupingBar='true' locale='de-DE' showFieldList='true'></ejs-pivotview></div>`
})

export class AppComponent {
    public dataSourceSettings?: DataSourceSettingsModel;
    public width?: string;
    ngOnInit(): void {
        L10n.load({
            'de-DE': {
                'pivotview': {
                    'grandTotal': 'Gesamtsumme',
                    'total': 'Insgesamt',
                    'value': 'Wert',
                    'noValue': 'Kein Wert',
                    'row': 'Zeile',
                    'column': 'Spalte',
                    'collapse': 'Zusammenbruch',
                    'expand': 'Erweitern'
                },
                "pivotfieldlist": {
                    'fieldList': 'Feld Liste',
                    'dropRowPrompt': 'Drop Reihe hier',
                    'dropColPrompt': 'Drop column Hier',
                    'dropValPrompt': 'Drop wert hier',
                    'dropFilterPrompt': 'Drop Filter Hier',
                    'addPrompt': 'Feld hinzufügen',
                    'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
                    'add': 'Hinzufügen',
                    'drag': 'Ziehen',
                    'filters': 'Filter',
                    'rows': 'Zeilen',
                    'columns': 'Spalten',
                    'values': 'Werte',
                    'error': 'Fehler',
                    'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
                    'search': 'Suche',
                    'close': 'Schließen',
                    'cancel': 'Abbrechen',
                    'delete': 'Löschen',
                    'alert': 'Warnung',
                    'warning': 'Warnung',
                    'ok': 'OK',
                    'allFields': 'Alle Felder',
                    'noMatches': 'Keine Treffer'
                }
            }
        });
        this.dataSourceSettings = {
            dataSource: Pivot_Data as IDataSet[],
            expandAll: false,
            enableSorting: true,
            columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
            values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
            rows: [{ name: 'Country' }, { name: 'Products' }],
            formatSettings: [{ name: 'Amount', format: 'C2', useGrouping: false,
                minimumSignificantDigits: 1, maximumSignificantDigits: 3, currency: 'EUR' }],
            filters: [],
            calculatedFieldSettings: [{ name: 'Total', formula: '"Sum(Amount)"+"Sum(Sold)"' }]
        };
        this.width = "100%";
    }
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

  • In the above example, the Amount field is formatted using NumberFormatOptions. For date formats, value strings are formatted using DateFormatOptions.
  • The default locale value is en-US. To change from the en-US culture to a different culture, update the locale property accordingly.
  • You can find more details about supported format strings for number and date formats here.

Decimal separators

The Pivot Table automatically adjusts decimal separators in numeric values to match your selected culture, making data easier to read for users from different regions. You can set the culture by calling the setCulture method with the appropriate culture string as its parameter. Once applied, all numeric values in the Pivot Table will display using the decimal separator convention of that culture.

For example, while English cultures typically use a dot (.) as the decimal separator, German culture uses a comma (,) instead.

The following example shows how decimal separators appear when using the Deutsch culture.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { PivotViewAllModule, PivotFieldListAllModule } from '@syncfusion/ej2-angular-pivotview'



import { Component } from '@angular/core';
import { loadCldr, L10n, setCulture, setCurrencyCode } from '@syncfusion/ej2-base';
import { IDataSet, FieldListService, CalculatedFieldService, GroupingBarService } from '@syncfusion/ej2-angular-pivotview';
import { Pivot_Data } from './datasource';
import * as currencies from './currencies.json';
import * as cagregorian from './ca-gregorian.json';
import * as numbers from './numbers.json';
import * as timeZoneNames from './timeZoneNames.json';
import * as numberingSystems from './numberingSystems.json';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';

loadCldr(currencies, cagregorian, numbers, timeZoneNames, numberingSystems);
setCulture('de');
setCurrencyCode('EUR');

@Component({
imports: [
        
        PivotViewAllModule,
        PivotFieldListAllModule
    ],


standalone: true,
  selector: 'app-container',
  providers: [FieldListService, CalculatedFieldService, GroupingBarService],
  // specifies the template string for the pivot table component
  template: `<div style="height: 480px;"><ejs-pivotview #pivotview id='PivotView' height='350' [dataSourceSettings]=dataSourceSettings [width]=width
  allowCalculatedField='true' showGroupingBar='true' locale='de-DE' showFieldList='true'></ejs-pivotview></div>`
})

export class AppComponent {
    public dataSourceSettings?: DataSourceSettingsModel;
    public width?: string;
    ngOnInit(): void {
        
        L10n.load({
            'de-DE': {
                'pivotview': {
                    'grandTotal': 'Gesamtsumme',
                    'total': 'Insgesamt',
                    'value': 'Wert',
                    'noValue': 'Kein Wert',
                    'row': 'Zeile',
                    'column': 'Spalte',
                    'collapse': 'Zusammenbruch',
                    'expand': 'Erweitern'
                },
                "pivotfieldlist": {
                    'fieldList': 'Feld Liste',
                    'dropRowPrompt': 'Drop Reihe hier',
                    'dropColPrompt': 'Drop column Hier',
                    'dropValPrompt': 'Drop wert hier',
                    'dropFilterPrompt': 'Drop Filter Hier',
                    'addPrompt': 'Feld hinzufügen',
                    'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
                    'add': 'Hinzufügen',
                    'drag': 'Ziehen',
                    'filters': 'Filter',
                    'rows': 'Zeilen',
                    'columns': 'Spalten',
                    'values': 'Werte',
                    'error': 'Fehler',
                    'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
                    'search': 'Suche',
                    'close': 'Schließen',
                    'cancel': 'Abbrechen',
                    'delete': 'Löschen',
                    'alert': 'Warnung',
                    'warning': 'Warnung',
                    'ok': 'OK',
                    'allFields': 'Alle Felder',
                    'noMatches': 'Keine Treffer'
                }
            }
        });
        this.dataSourceSettings = {
            dataSource: Pivot_Data as IDataSet[],
            columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
            values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
            rows: [{ name: 'Country' }, { name: 'Products' }],
            formatSettings: [{ name: 'Amount', format: 'C2', currency: 'EUR' }],
            filters: [],
            calculatedFieldSettings: [{ name: 'Total', formula: '"Sum(Amount)"+"Sum(Sold)"' }]
        };
        this.width = "100%";
    }
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Localization

The Localization option allows you to translate the default text content of the Pivot Table into different languages. This makes the component more accessible to users from various regions by displaying text in their preferred language.

The Pivot Table contains static text elements such as drop area messages, field list titles, and other interface labels that can be translated to different cultures (Arabic, German, French, etc.). You can achieve this by setting the locale property and providing the appropriate translation object.

The following table shows the locale keywords and their corresponding default text values used in the Pivot Table:

Locale keywords Text
grandTotal Grand Total
total Total
value Value
noValue No value
row Row
column Column
collapse Collapse
expand Expand
rowAxisPrompt Drop row here
columnAxisPrompt Drop column here
valueAxisPrompt Drop value here
filterAxisPrompt Drop filter here
filter Filter
filtered Filtered
sort Sort
filters Filters
rows Rows
columns Columns
values Values
close Close
cancel Cancel
delete Delete
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
alert Alert
warning Warning
ok OK
search Search
drag Drag
remove Remove
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
addToRow Add to Row
addToColumn Add to Column
addToValue Add to Value
addToFilter Add to Filter
emptyData No records to display
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
all All
multipleItems Multiple items
member Member
label Label
date Date
enterValue Enter value
chooseDate Enter date
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
And and
DistinctCount Distinct Count
Product Product
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
NotEquals Not Equals
AllValues All Values
conditionalFormatting Conditional Formatting
apply APPLY
condition Add Condition
formatLabel Format
valueFieldSettings Value field settings
baseField Base field :
baseItem Base item :
summarizeValuesBy Summarize values by :
sourceName Field name :
sourceCaption Field caption :
example e.g:
editorDataLimitMsg more items. Search to refine further.
details Details
manageRecords Manage Records
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
save Save a report
new Create a new report
load Load
saveAs Save as current report
rename Rename a current report
deleteReport Delete a current report
export Export
subTotals Sub totals
grandTotals Grand totals
reportName Report Name :
pdf PDF
excel Excel
csv CSV
png PNG
jpeg JPEG
svg SVG
mdxQuery MDX Query
showSubTotals Show subtotals
doNotShowSubTotals Do not show subtotals
showSubTotalsRowsOnly Show subtotals rows only
showSubTotalsColumnsOnly Show subtotals columns only
showGrandTotals Show grand totals
doNotShowGrandTotals Do not show grand totals
showGrandTotalsRowsOnly Show grand totals rows only
showGrandTotalsColumnsOnly Show grand totals columns only
fieldList Show fieldlist
grid Show table
toolbarFormatting Conditional formatting
chart Chart
reportMsg Please enter valid report name!!!
reportList Report list
removeConfirm Are you sure want to delete this report?
emptyReport No reports found!!
bar Bar
line Line
area Area
scatter Scatter
polar Polar
of of
emptyFormat No format found!!!
emptyInput Enter a value
newReportConfirm Want to save changes to report?
emptyReportName Enter a report name
qtr Qtr
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
aggregate Aggregate
drillThrough Drill Through
ascending Ascending
descending Descending
number Number
currency Currency
percentage Percentage
formatType Format Type
customText Currency Symbol
symbolPosition Symbol Position
left Left
right Right
grouping Grouping
true True
false False
decimalPlaces Decimal Places
numberFormat Number Formatting
memberType Field Type
formatString Format String
expressionField Expression
customFormat Enter custom format string
selectedHierarchy Parent Hierarchy
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
Percent Percent
Custom Custom
Measure Measure
Dimension Dimension
Standard Standard
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! Then you can achieve it by simply selecting the field under ‘Calculated Members’.
QuarterYear Quarter Year
fieldTitle Field Name
drillError Cannot show the raw items of calculated fields.
caption Field Caption
copy Copy
defaultReport Default report
customFormatString Custom Format
invalidFormat Invalid Format.
group Group
unGroup Ungroup
invalidSelection Cannot group that selection.
groupName Enter the caption to display in header
captionName Enter the caption for group field
selectedItems Selected items
groupFieldCaption Field caption
groupTitle Group name
startAt Starting at
endAt Ending at
groupBy Interval by
selectGroup Select groups
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
stackingcolumn Stacked Column
stackingbar Stacked Bar
stackingarea Stacked Area
stepline Step Line
steparea Step Area
splinearea Spline Area
spline Spline
stackingcolumn100 100% Stacked Column
stackingbar100 100% Stacked Bar
stackingarea100 100% Stacked Area
bubble bubble
pareto Pareto
radar Radar
chartTypeSettings Chart type settings
multipleAxes Multiple Axes
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
ChartType Chart Type
yes Yes
no No
numberFormatMenu Number Formatting…
conditionalFormattingMenu Conditional Formatting…
removeCalculatedField Are you sure you want to delete this calculated field?
replaceConfirmBefore A report named
replaceConfirmAfter already exists. Do you want to replace it?
pie Pie
funnel Funnel
doughnut Doughnut
pyramid Pyramid
showLegend Show Legend
exit Exit
invalidJSON Invalid JSON data
invalidCSV Invalid CSV data
stacked Stacked
single Single
multipleAxisMode Multiple Axis Mode
grandTotalPosition Grand totals position
top Top
bottom Bottom
None None
stackingline Stacked Line
stackingline100 100% Stacked Line
rowPage Row pager
rowPerPage Rows per page
columnPage Column pager
columnPerPage Columns per page
goToFirstPage Go to first page
goToPreviousPage Go to previous page
goToNextPage Go to next page
goToLastPage Go to last page
combined Combined
subTotalPosition Subtotals position
auto Auto

The following list of properties and its values are used in the pivot field list.

Locale keywords Text
staticFieldList Pivot Field List
fieldList Field List
dropFilterPrompt Drop filter here
dropColPrompt Drop column here
dropRowPrompt Drop row here
dropValPrompt Drop value here
addPrompt Add field here
adaptiveFieldHeader Choose field
centerHeader Drag fields between axes below:
add add
drag Drag
filter Filter
filtered Filtered
sort Sort
remove Remove
filters Filters
rows Rows
columns Columns
values Values
CalculatedField Calculated Field
createCalculatedField Create Calculated Field
fieldName Enter the field name
error Error
invalidFormula Invalid formula.
dropText Example: (‘Sum(Order_Count)’ + ‘Sum(In_Stock)’) * 250
dropTextMobile Add fields and edit formula here.
dropAction Calculated field cannot be place in any other region except value axis.
search Search
close Close
cancel Cancel
delete Delete
alert Alert
warning Warning
ok OK
Sum Sum
Avg Avg
Count Count
Min Min
Max Max
allFields All Fields
formula Formula
fieldExist A field already exists in this name. Please enter a different name.
confirmText A calculation field already exists in this name. Do you want to replace it?
noMatches No matches
format Summaries values by
edit Edit
clear Clear
formulaField Drag and drop fields to formula
dragField Drag field to formula
clearFilter Clear
by by
enterValue Enter value
chooseDate Enter date
all All
multipleItems Multiple items
Equals Equals
DoesNotEquals Does Not Equal
BeginWith Begins With
DoesNotBeginWith Does Not Begin With
EndsWith Ends With
DoesNotEndsWith Does Not End With
Contains Contains
DoesNotContains Does Not Contain
GreaterThan Greater Than
GreaterThanOrEqualTo Greater Than Or Equal To
LessThan Less Than
LessThanOrEqualTo Less Than Or Equal To
Between Between
NotBetween Not Between
Before Before
BeforeOrEqualTo Before Or Equal To
After After
AfterOrEqualTo After Or Equal To
member Member
label Label
date Date
value Value
labelTextContent Show the items for which the label
dateTextContent Show the items for which the date
valueTextContent Show the items for which
And and
DistinctCount Distinct Count
Product Product
Index Index
SampleStDev Sample StDev
PopulationStDev Population StDev
SampleVar Sample Var
PopulationVar Population Var
RunningTotals Running Totals
DifferenceFrom Difference From
PercentageOfDifferenceFrom % of Difference From
PercentageOfGrandTotal % of Grand Total
PercentageOfColumnTotal % of Column Total
PercentageOfRowTotal % of Row Total
PercentageOfParentTotal % of Parent Total
PercentageOfParentColumnTotal % of Parent Column Total
PercentageOfParentRowTotal % of Parent Row Total
Years Years
Quarters Quarters
Months Months
Days Days
Hours Hours
Minutes Minutes
Seconds Seconds
apply APPLY
valueFieldSettings Value field settings
sourceName Field name :
sourceCaption Field caption :
summarizeValuesBy Summarize values by :
baseField Base field :
baseItem Base item :
example e.g:
editorDataLimitMsg more items. Search to refine further.
deferLayoutUpdate Defer Layout Update
null null
undefined undefined
groupOutOfRange Out of Range
fieldDropErrorAction The field you are moving cannot be placed in that area of the report
MoreOption More…
memberType Field Type
selectedHierarchy Parent Hierarchy
formatString Format String
expressionField Expression
olapDropText Example: [Measures].[Order Quantity] + ([Measures].[Order Quantity] * 0.10)
customFormat Enter custom format string
Measure Measure
Dimension Dimension
Standard Standard
Currency Currency
Percent Percent
Custom Custom
blank (Blank)
fieldTooltip Drag and drop fields to create an expression. And, if you want to edit the existing the calculated fields! You can achieve it by simply selecting the field under ‘Calculated Members’.
fieldTitle Field Name
QuarterYear Quarter Year
caption Field Caption
copy Copy
group Group
numberFormatString Example: C, P, 0000 %, ###0.##0#, etc.
sortAscending Sort ascending order
sortDescending Sort descending order
sortNone Sort data order
clearCalculatedField Clear edited field info
editCalculatedField Edit calculated field
selectGroup Select groups
of of
removeCalculatedField Are you sure you want to delete this calculated field?
yes Yes
no No
None None

NOTE

To access the most recent localization keywords for the Pivot Table and Pivot Field List components in different languages, visit the GitHub repository.

Loading Translations

To load translation content in your application, use the load method of the L10n class. This method accepts translation objects that contain text content in different languages.

The following example shows how to display the Pivot Table in German (Deutsch) culture:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { PivotViewAllModule, PivotFieldListAllModule } from '@syncfusion/ej2-angular-pivotview'



import { Component } from '@angular/core';
import { L10n } from '@syncfusion/ej2-base';
import { IDataSet, FieldListService, CalculatedFieldService, GroupingBarService } from '@syncfusion/ej2-angular-pivotview';
import { Pivot_Data } from './datasource';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';

@Component({
imports: [
        
        PivotViewAllModule,
        PivotFieldListAllModule
    ],


standalone: true,
  selector: 'app-container',
  providers: [FieldListService, CalculatedFieldService, GroupingBarService],
  // specifies the template string for the pivot table component
  template: `<div style="height: 480px;"><ejs-pivotview #pivotview id='PivotView' height='350' [dataSourceSettings]=dataSourceSettings [width]=width
  allowCalculatedField='true' showGroupingBar='true' locale='de-DE' showFieldList='true'></ejs-pivotview></div>`
})

export class AppComponent {
    public dataSourceSettings?: DataSourceSettingsModel;
    public width?: string;
    ngOnInit(): void {
        L10n.load({
            'de-DE': {
                'pivotview': {
                    'grandTotal': 'Gesamtsumme',
                    'total': 'Insgesamt',
                    'value': 'Wert',
                    'noValue': 'Kein Wert',
                    'row': 'Zeile',
                    'column': 'Spalte',
                    'collapse': 'Zusammenbruch',
                    'expand': 'Erweitern'
                },
                "pivotfieldlist": {
                    'fieldList': 'Feld Liste',
                    'dropRowPrompt': 'Drop Reihe hier',
                    'dropColPrompt': 'Drop column Hier',
                    'dropValPrompt': 'Drop wert hier',
                    'dropFilterPrompt': 'Drop Filter Hier',
                    'addPrompt': 'Feld hinzufügen',
                    'centerHeader': 'Ziehen Sie die Felder zwischen den Bereichen unten:',
                    'add': 'Hinzufügen',
                    'drag': 'Ziehen',
                    'filters': 'Filter',
                    'rows': 'Zeilen',
                    'columns': 'Spalten',
                    'values': 'Werte',
                    'error': 'Fehler',
                    'dropAction': 'Berechnetes Feld nicht in jeder anderen Region außer Wert Achse sein.',
                    'search': 'Suche',
                    'close': 'Schließen',
                    'cancel': 'Abbrechen',
                    'delete': 'Löschen',
                    'alert': 'Warnung',
                    'warning': 'Warnung',
                    'ok': 'OK',
                    'allFields': 'Alle Felder',
                    'noMatches': 'Keine Treffer'
                }
            }
        });
        this.dataSourceSettings = {
            dataSource: Pivot_Data as IDataSet[],
            expandAll: false,
            enableSorting: true,
            columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
            values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
            rows: [{ name: 'Country' }, { name: 'Products' }],
            formatSettings: [{ name: 'Amount', format: 'C0' }],
            filters: [],
            calculatedFieldSettings: [{ name: 'Total', formula: '"Sum(Amount)"+"Sum(Sold)"' }]
        };
        this.width = "100%";
    }
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Right-to-left (RTL)

Right-to-left (RTL) support makes the Pivot Table more accessible and user-friendly for people who read and write in right-to-left languages such as Arabic, Farsi, and Urdu. This feature adjusts the text direction and layout of the entire Pivot Table from a left-to-right to a right-to-left orientation. To enable RTL in the Pivot Table, set the enableRtl property to true.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { PivotViewAllModule, PivotFieldListAllModule } from '@syncfusion/ej2-angular-pivotview'



import { Component } from '@angular/core';
import { L10n } from '@syncfusion/ej2-base';
import { IDataSet, FieldListService, CalculatedFieldService, GroupingBarService } from '@syncfusion/ej2-angular-pivotview';
import { Pivot_Data } from './datasource';
import { DataSourceSettingsModel } from '@syncfusion/ej2-pivotview/src/model/datasourcesettings-model';

@Component({
imports: [
        
        PivotViewAllModule,
        PivotFieldListAllModule
    ],


standalone: true,
  selector: 'app-container',
  providers: [FieldListService, CalculatedFieldService, GroupingBarService],
  // specifies the template string for the pivot table component
  template: `<div style="height: 480px;"><ejs-pivotview #pivotview id='PivotView' [dataSourceSettings]=dataSourceSettings [width]=width
  allowCalculatedField='true' showGroupingBar='true' locale='ar-AE' enableRtl= true showFieldList='true'></ejs-pivotview></div>`
})

export class AppComponent {
    public dataSourceSettings?: DataSourceSettingsModel;
    public width?: string;
    ngOnInit(): void {
        L10n.load({
            'ar-AE': {
                'pivotview': {
                    'grandTotal': 'المجموع الكلى',
                    'total': 'المجموع',
                    'value': 'القيمة',
                    'noValue': 'لا قيمة لها',
                    'row': 'صف',
                    'column': 'العمود',
                    'collapse': 'الانهيار',
                    'expand': 'توسيع'
                },
                'pivotfieldlist': {
                    'fieldList': 'قائمة الحقول',
                    'dropRowPrompt': 'تراجع الخلاف هنا',
                    'dropColPrompt': 'انخفاض العمود هنا',
                    'dropValPrompt': 'انخفاض قيمة هنا',
                    'dropFilterPrompt': 'انخفاض هنا عامل التصفية',
                    'addPrompt': 'اضافة حقل هنا',
                    'adaptiveFieldHeader': 'اختر الحقل',
                    'centerHeader': 'اسحب المجالات بين المناطق الموضحة ادناه:',
                    'add': 'اضافة',
                    'drag': 'اسحب',
                    'filters': 'عوامل التصفية',
                    'rows': 'الصفوف',
                    'columns': 'الاعمدة',
                    'values': 'قيم',
                    'search': 'البحث',
                    'close': 'قريب',
                    'cancel': 'الغاء',
                    'delete': 'احذف',
                    'alert': 'حالة تاهب قصوى',
                    'warning': 'تحذير',
                    'ok': 'موافق',
                    'allFields': 'جميع الحقول',
                    'noMatches': 'لا مباريات'
                }
            }
        });
        this.dataSourceSettings = {
            dataSource: Pivot_Data as IDataSet[],
            expandAll: false,
            enableSorting: true,
            columns: [{ name: 'Year', caption: 'Production Year' }, { name: 'Quarter' }],
            values: [{ name: 'Sold', caption: 'Units Sold' }, { name: 'Amount', caption: 'Sold Amount' }],
            rows: [{ name: 'Country' }, { name: 'Products' }],
            formatSettings: [{ name: 'Amount', format: 'C0' }],
            filters: [],
            calculatedFieldSettings: [{ name: 'Total', formula: '"Sum(Amount)"+"Sum(Sold)"' }]
        };
        this.width = "100%";
    }
 }
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

See Also